const char *SyncEvolutionXMLClient =
"<?xml version=\"1.0\"?>\n"
"<!-- SYNTHESIS SYNCML CLIENT Version 3.2 Configuration file -->\n"
"\n"
"<sysync_config version=\"1.0\">\n"
"\n"
"  <configvar name=\"logpath\" value=\"$(defout_path)\"/>\n"
"\n"
"  <!-- this string is output to every session debug logfile to identify the config in use -->\n"
"  <configidstring>SyncEvolution client config</configidstring>\n"
"\n"
"  <!-- information about maximum supported message and object size (in bytes) -->\n"
"  <maxmsgsize/>\n"
"  <maxobjsize/>\n"
"\n"
"  <!-- information for DevInf -->\n"
"  <model/>\n"
"  <manufacturer/>\n"
"  <hardwareversion/>\n"
"  <firmwareversion/>\n"
"  <devicetype/>\n"
"  <configdate/>\n"
"\n"
"  <debug/>\n"
"\n"
"  <transport type=\"xpt\">\n"
"    <!-- allow HTTP 1.1 kepp-alive (multiple request-answer-exchanges in single TCP connection) -->\n"
"    <keepconnection>true</keepconnection>\n"
"  </transport>\n"
"\n"
"  <scripting>\n"
"<!-- disable endless loop prevention, shouldn't be needed and may abort prematurely -->\n"
"<looptimeout>0</looptimeout>\n"
"    <macro name=\"VCARD_INCOMING_PHOTO_VALUE_SCRIPT\"><![CDATA[\n"
"      // Ensure that PHOTO_VALUE is set to \"binary\" if not set (the default).\n"
"      // Avoids potential issues when merging.\n"
"      if (PHOTO_VALUE == EMPTY) {\n"
"          PHOTO_VALUE = \"binary\";\n"
"      }\n"
"      // same for PHOTO_TYPE, except that we have no good default.\n"
"      if (PHOTO_TYPE == EMPTY) {\n"
"          PHOTO_TYPE = \"unknown\";\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_INCOMING_PHOTO_TYPE_SCRIPT\"><![CDATA[\n"
"      // Fix PHOTO TYPE=image/jpeg (sent by Funambol).\n"
"      INTEGER pos;\n"
"      pos = RFIND(PHOTO_TYPE, \"/\", SIZE(PHOTO_TYPE));\n"
"      if (pos != UNASSIGNED) {\n"
"          PHOTO_TYPE = SUBSTR(PHOTO_TYPE, pos + 1);\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_OUTGOING_PHOTO_VALUE_SCRIPT\"><![CDATA[\n"
"      // Ensure that PHOTO_VALUE == \"binary\" is not sent (it's the default).\n"
"      if (PHOTO_VALUE == \"binary\") {\n"
"          PHOTO_VALUE = UNASSIGNED;\n"
"      }\n"
"      // Hide our internal photo type default.\n"
"      if (PHOTO_TYPE == \"unknown\") {\n"
"          PHOTO_TYPE = UNASSIGNED;\n"
"      }\n"
"    ]]></macro>\n"
"    <macro name=\"VCARD_OUTGOING_PHOTO_INLINING_SCRIPT\"><![CDATA[\n"
"      if (PHOTO_VALUE == \"uri\") {\n"
"          string path;\n"
"          path = URITOPATH(PHOTO);\n"
"          if (path) {\n"
"              // try to inline the photo data\n"
"              string data;\n"
"              data = READ(path);\n"
"              if (data != UNASSIGNED) {\n"
"                  PHOTO = data;\n"
"                  PHOTO_VALUE = \"binary\";\n"
"              }\n"
"          }\n"
"      }\n"
"    ]]></macro>\n"
"   <macro name=\"VCARD_BEFOREWRITE_SCRIPT_EVOLUTION\"><![CDATA[\n"
"     // a wordaround for cellphone in evolution. for incoming contacts, if there is only one CELL,\n"
"     // strip the HOME or WORK flag from it. Evolution then should show it. */\n"
"     INTEGER i, wanted, cell_phones;\n"
"     i = 0;\n"
"     cell_phones = 0;\n"
"     while(i < SIZE(TEL_FLAGS)) {\n"
"       // 0x10 is the flag of 'cell' type of telephone\n"
"       if(TEL_FLAGS[i] & 0x10) {\n"
"         cell_phones = cell_phones + 1;\n"
"         wanted = i;\n"
"       }\n"
"       i = i + 1;\n"
"     }\n"
"     if(cell_phones == 1) {\n"
"       TEL_FLAGS[wanted] = 0x10;\n"
"     }\n"
"\n"
"     // Google sends TYPE=WORK and TYPE=HOME when it means\n"
"     // normal VOICE phone numbers. Add that flag when\n"
"     // importing into Evolution, because Evolution does not\n"
"     // display the numbers without VOICE.\n"
"     i = 0;\n"
"     while(i < SIZE(TEL_FLAGS)) {\n"
"       if(TEL_FLAGS[i] == 1 || TEL_FLAGS[i] == 2) {\n"
"         TEL_FLAGS[i] = TEL_FLAGS[i] | 8;\n"
"       }\n"
"       i = i + 1;\n"
"     }\n"
"\n"
"     if (N_LAST == EMPTY && N_FIRST == EMPTY && N_MIDDLE == EMPTY) {\n"
"         // split full name (FN) into first/middle/last components (N)\n"
"         // when those are empty, because Evolution and MeeGo UX depend on them\n"
"         integer i;\n"
"         // split at spaces\n"
"         string words[];\n"
"         integer numwords;\n"
"         string name;\n"
"         integer start;\n"
"         integer space;\n"
"         integer namelen;\n"
"         name = NORMALIZED(FN);\n"
"         namelen = SIZE(name);\n"
"         start = 0;\n"
"         numwords = 0;\n"
"         while (TRUE) {\n"
"            space = FIND(name, \" \", start);\n"
"            if (space) {\n"
"               words[numwords] = SUBSTR(name, start, space - start);\n"
"               numwords = numwords + 1;\n"
"               start = space + 1;\n"
"               name;\n"
"               while (SUBSTR(name, start, 1) == \" \") {\n"
"                   start = start + 1;\n"
"               }\n"
"            } else {\n"
"               if (start < namelen) {\n"
"                  words[numwords] = SUBSTR(name, start);\n"
"                  numwords = numwords + 1;\n"
"               }\n"
"               break;\n"
"            }\n"
"         }\n"
"\n"
"         if (numwords == 0) {\n"
"             // use email address, phone number, etc. as fallback\n"
"             N_FIRST = EMAIL[0];\n"
"             if (N_FIRST == EMPTY) {\n"
"                N_FIRST = TEL[0];\n"
"             }\n"
"         } else if (numwords == 1) {\n"
"             N_FIRST = words[0];\n"
"         } else {\n"
"             // start and end index of middle name(s), both inclusive\n"
"             integer startmiddle;\n"
"             integer endmiddle;\n"
"             name = words[0];\n"
"             namelen = SIZE(name);\n"
"             // last name given first as in \"Doe, John\"?\n"
"             if (SUBSTR(name, namelen - 1, 1) == \",\") {\n"
"                 N_LAST = SUBSTR(name, 0, namelen - 1);\n"
"                 N_FIRST = words[1];\n"
"                 startmiddle = 2;\n"
"                 endmiddle = numwords - 1;\n"
"             } else {\n"
"                 N_FIRST = name;\n"
"                 startmiddle = 1;\n"
"                 endmiddle = numwords - 2;\n"
"                 N_LAST = words[numwords - 1];\n"
"             }\n"
"\n"
"             if (endmiddle >= startmiddle) {\n"
"                 N_MIDDLE = words[startmiddle];\n"
"                 startmiddle = startmiddle + 1;\n"
"                 while (endmiddle >= startmiddle) {\n"
"                    N_MIDDLE = N_MIDDLE + \" \" + words[startmiddle];\n"
"                    startmiddle = startmiddle + 1;\n"
"                 }\n"
"             }\n"
"         }\n"
"     }\n"
"\n"
"     // Ensure that FILE-AS is set. Some EDS versions will set it,\n"
"     // so we need to do the same to ensure that incoming items\n"
"     // match DB items during a slow sync.\n"
"     if (FILE_AS == EMPTY) {\n"
"        FILE_AS = N_LAST;\n"
"        if (N_FIRST != EMPTY) {\n"
"           if (FILE_AS != EMPTY) {\n"
"              FILE_AS = FILE_AS + \", \";\n"
"           }\n"
"           FILE_AS = FILE_AS + N_FIRST;\n"
"        }\n"
"     }\n"
"\n"
"     $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT;\n"
"   ]]></macro>\n"
"\n"
"   <macro name=\"VCARD_AFTERREAD_SCRIPT_EVOLUTION\"><![CDATA[\n"
"     $VCARD_INCOMING_PHOTO_VALUE_SCRIPT;\n"
"   ]]></macro>\n"
"   <!-- Special treatment of PHOTO data: keep a local file if it has the\n"
"        same content as the binary data in the winning item.\n"
"        Use in combination with a PHOTO field of type=\"string\" (not blob,\n"
"        because we need to be able to compare the field in the MERGEFIELDS()\n"
"        call to detect when the data really changes) and compare=\"conflict\"\n"
"        (not used to find matches, changes are relevant).\n"
"   -->\n"
"   <macro name=\"VCARD_MERGESCRIPT\"><![CDATA[\n"
"     integer mode;\n"
"     mode = MERGEMODE();\n"
"\n"
"     INTEGER winningchanged;\n"
"     INTEGER loosingchanged;\n"
"     winningchanged = 0;\n"
"     loosingchanged = 0;\n"
"\n"
"     STRING ignorefields;\n"
"     ignorefields = \"\";\n"
"\n"
"     if (SESSIONVAR(\"keepPhotoData\") &&\n"
"         WINNING.PHOTO == EMPTY &&\n"
"         LOOSING.PHOTO != EMPTY) {\n"
"       // The client's item is always the \"winning\" one in PBAP syncing,\n"
"       // but it might not have the photo data that is already on the\n"
"       // server. Therefore keep the server's photo, if there is\n"
"       // one and we are not in the phase where the client sends\n"
"       // its photos.\n"
"       WINNING.PHOTO = LOOSING.PHOTO;\n"
"       WINNING.PHOTO_TYPE = LOOSING.PHOTO_TYPE;\n"
"       WINNING.PHOTO_VALUE = LOOSING.PHOTO_VALUE;\n"
"       winningchanged = 1;\n"
"     } else if (mode == 1 && WINNING.PHOTO == EMPTY) {\n"
"       // Removing photo from loosing item.\n"
"       if (LOOSING.PHOTO != EMPTY) {\n"
"         loosingchanged = 1;\n"
"       }\n"
"       LOOSING.PHOTO = EMPTY;\n"
"       LOOSING.PHOTO_TYPE = \"\";\n"
"       LOOSING.PHOTO_VALUE = \"\";\n"
"     } else if (LOOSING.PHOTO != EMPTY) {\n"
"       // Updating photo. Might actually be the same!\n"
"       if (LOOSING.PHOTO_VALUE == \"uri\" && (WINNING.PHOTO_VALUE == EMPTY || WINNING.PHOTO_VALUE == \"binary\")) {\n"
"         string path;\n"
"         path = URITOPATH(LOOSING.PHOTO);\n"
"         if (path) {\n"
"           if (READ(path) == WINNING.PHOTO) {\n"
"             // Reuse photo file from loosing item.\n"
"             // If we need to write back for some other reason, we'll inline the data again.\n"
"             WINNING.PHOTO = LOOSING.PHOTO;\n"
"             WINNING.PHOTO_TYPE = LOOSING.PHOTO_TYPE;\n"
"             WINNING.PHOTO_VALUE = LOOSING.PHOTO_VALUE;\n"
"           }\n"
"         }\n"
"       }\n"
"     } else {\n"
"       LOOSING.PHOTO_VALUE = EMPTY;\n"
"       LOOSING.PHOTO_TYPE = EMPTY;\n"
"       LOOSING.PHOTO = EMPTY;\n"
"     }\n"
"\n"
"     // In cache mode, we don't care about the order of entries, so\n"
"     // we do our own relaxed comparison and tell the engine to ignore\n"
"     // fields if the only change is in the ordering.\n"
"     if (CACHEDATA()) {\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"TEL\", \"\", \"TEL_FLAGS\", \"TEL_SLOT\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"XDATE\", \"\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"EMAIL\", \"\", \"EMAIL_FLAGS\", \"EMAIL_SLOT\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"WEB\", \"\", \"WEB_FLAGS\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"CALURI\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"FBURL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"BLOGURL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"VIDEOURL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"RELATEDNAMES\", \"\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"IMPP\", \"\", \"IMPP_SERVICE\", \"IMPP_SLOT\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"AIM_HANDLE\", \"\", \"AIM_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"GADUGADU_HANDLE\", \"\", \"GADUGADU_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"GROUPWISE_HANDLE\", \"\", \"GROUPWISE_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"ICQ_HANDLE\", \"\", \"ICQ_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"JABBER_HANDLE\", \"\", \"JABBER_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"MSN_HANDLE\", \"\", \"MSN_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"YAHOO_HANDLE\", \"\", \"YAHOO_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"SKYPE_HANDLE\", \"\", \"SKYPE_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"SIP_HANDLE\", \"\", \"SIP_SLOT\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"EMAIL\", \"\", \"EMAIL_FLAGS\", \"EMAIL_SLOT\", \"LABEL\");\n"
"       ignorefields = ignorefields + RELAXEDCOMPARE(\"ADR\", \"ADR_STREET\", \"ADR_ADDTL\", \"ADR_STREET_FLAGS\", \"ADR_POBOX\", \"ADR_CITY\", \"ADR_REG\", \"ADR_ZIP\", \"ADR_COUNTRY\", \"\", \"LABEL\");\n"
"\n"
"       // Always ignore the label. Otherwise reordering will cause unnecessary\n"
"       // writes. We check for reordering more selectively above, but because\n"
"       // the LABEL field is shared, we cannot do the same for it.\n"
"       // The downside is that changes in just the label of an entry will not\n"
"       // cause an update of the cache. Some other value must be modified, too,\n"
"       // to trigger a write.\n"
"       ignorefields = ignorefields + \" LABEL\";\n"
"     }\n"
"\n"
"     // When running in caching mode, we end up executing the merge script,\n"
"     // but in that case we want to remove data from the loosing item and\n"
"     // thus need to skip the array merging.\n"
"     if (!CACHEDATA()) {\n"
"       // Merge arrays such that the superset remains in the winning item.\n"
"       // The arrays then get copied wholesale to the loosing item.\n"
"       // Items which share the label array must avoid conflicts in the label\n"
"       // array, the others don't.\n"
"       // See \"[SyncEvolution] merging of winning and loosing items\"\n"
"       INTEGER i;\n"
"       INTEGER num;\n"
"       TELEPHONE tel;\n"
"       DATE xdate;\n"
"       STRING val;\n"
"\n"
"       i = SIZE(LOOSING.TEL) - 1;\n"
"       while (i >= 0) {\n"
"          tel = LOOSING.TEL[i];\n"
"          if (tel != EMPTY &&\n"
"              !CONTAINS(WINNING.TEL, tel)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.TEL[num] = tel;\n"
"             WINNING.TEL_FLAGS[num] = LOOSING.TEL_FLAGS[i];\n"
"             WINNING.TEL_SLOT[num] = LOOSING.TEL_SLOT[i];\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.XDATE) - 1;\n"
"       while (i >= 0) {\n"
"          xdate = LOOSING.XDATE[i];\n"
"          if (xdate != EMPTY &&\n"
"              !CONTAINS(WINNING.XDATE, xdate)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.XDATE[num] = xdate;\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.EMAIL) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.EMAIL[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.EMAIL, val)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.EMAIL[num] = val;\n"
"             WINNING.EMAIL_FLAGS[num] = LOOSING.EMAIL_FLAGS[i];\n"
"             WINNING.EMAIL_SLOT[num] = LOOSING.EMAIL_SLOT[i];\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.WEB) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.WEB[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.WEB, val)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.WEB[num] = val;\n"
"             WINNING.WEB_FLAGS[num] = LOOSING.WEB_FLAGS[i];\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.CALURI) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.CALURI[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.CALURI, val)) {\n"
"             num = SIZE(WINNING.CALURI);\n"
"             WINNING.CALURI[num] = val;\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.FBURL) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.FBURL[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.FBURL, val)) {\n"
"             num = SIZE(WINNING.FBURL);\n"
"             WINNING.FBURL[num] = val;\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.BLOGURL) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.BLOGURL[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.BLOGURL, val)) {\n"
"             num = SIZE(WINNING.BLOGURL);\n"
"             WINNING.BLOGURL[num] = val;\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.VIDEOURL) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.VIDEOURL[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.VIDEOURL, val)) {\n"
"             num = SIZE(WINNING.VIDEOURL);\n"
"             WINNING.VIDEOURL[num] = val;\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.RELATEDNAMES) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.RELATEDNAMES[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.RELATEDNAMES, val)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.RELATEDNAMES[num] = val;\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.IMPP) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.IMPP[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.IMPP, val)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.IMPP[num] = val;\n"
"             WINNING.IMPP_SERVICE[num] = LOOSING.IMPP_SERVICE[i];\n"
"             WINNING.IMPP_SLOT[num] = LOOSING.IMPP_SLOT[i];\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.AIM_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.AIM_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.AIM_HANDLE, val)) {\n"
"             num = SIZE(WINNING.AIM_HANDLE);\n"
"             WINNING.AIM_HANDLE[num] = val;\n"
"             WINNING.AIM_SLOT[num] = LOOSING.AIM_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.GADUGADU_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.GADUGADU_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.GADUGADU_HANDLE, val)) {\n"
"             num = SIZE(WINNING.GADUGADU_HANDLE);\n"
"             WINNING.GADUGADU_HANDLE[num] = val;\n"
"             WINNING.GADUGADU_SLOT[num] = LOOSING.GADUGADU_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.GROUPWISE_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.GROUPWISE_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.GROUPWISE_HANDLE, val)) {\n"
"             num = SIZE(WINNING.GROUPWISE_HANDLE);\n"
"             WINNING.GROUPWISE_HANDLE[num] = val;\n"
"             WINNING.GROUPWISE_SLOT[num] = LOOSING.GROUPWISE_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.ICQ_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.ICQ_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.ICQ_HANDLE, val)) {\n"
"             num = SIZE(WINNING.ICQ_HANDLE);\n"
"             WINNING.ICQ_HANDLE[num] = val;\n"
"             WINNING.ICQ_SLOT[num] = LOOSING.ICQ_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.JABBER_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.JABBER_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.JABBER_HANDLE, val)) {\n"
"             num = SIZE(WINNING.JABBER_HANDLE);\n"
"             WINNING.JABBER_HANDLE[num] = val;\n"
"             WINNING.JABBER_SLOT[num] = LOOSING.JABBER_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.MSN_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.MSN_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.MSN_HANDLE, val)) {\n"
"             num = SIZE(WINNING.MSN_HANDLE);\n"
"             WINNING.MSN_HANDLE[num] = val;\n"
"             WINNING.MSN_SLOT[num] = LOOSING.MSN_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.YAHOO_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.YAHOO_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.YAHOO_HANDLE, val)) {\n"
"             num = SIZE(WINNING.YAHOO_HANDLE);\n"
"             WINNING.YAHOO_HANDLE[num] = val;\n"
"             WINNING.YAHOO_SLOT[num] = LOOSING.YAHOO_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.SKYPE_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.SKYPE_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.SKYPE_HANDLE, val)) {\n"
"             num = SIZE(WINNING.SKYPE_HANDLE);\n"
"             WINNING.SKYPE_HANDLE[num] = val;\n"
"             WINNING.SKYPE_SLOT[num] = LOOSING.SKYPE_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"       i = SIZE(LOOSING.SIP_HANDLE) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.SIP_HANDLE[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.SIP_HANDLE, val)) {\n"
"             num = SIZE(WINNING.SIP_HANDLE);\n"
"             WINNING.SIP_HANDLE[num] = val;\n"
"             WINNING.SIP_SLOT[num] = LOOSING.SIP_SLOT[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.EMAIL) - 1;\n"
"       while (i >= 0) {\n"
"          val = LOOSING.EMAIL[i];\n"
"          if (val != EMPTY &&\n"
"              !CONTAINS(WINNING.EMAIL, val)) {\n"
"             num = SIZE(WINNING.LABEL);\n"
"             WINNING.EMAIL[num] = val;\n"
"             WINNING.EMAIL_FLAGS[num] = LOOSING.EMAIL_FLAGS[i];\n"
"             WINNING.EMAIL_SLOT[num] = LOOSING.EMAIL_SLOT[i];\n"
"             WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"             winningchanged = 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       i = SIZE(LOOSING.ADR_STREET) - 1;\n"
"       INTEGER e;\n"
"       INTEGER contained;\n"
"       while (i >= 0) {\n"
"          if (LOOSING.ADR_STREET[i] != EMPTY ||\n"
"              LOOSING.ADR_ADDTL[i] != EMPTY ||\n"
"              LOOSING.ADR_STREET_FLAGS[i] != EMPTY ||\n"
"              LOOSING.ADR_POBOX[i] != EMPTY ||\n"
"              LOOSING.ADR_CITY[i] != EMPTY ||\n"
"              LOOSING.ADR_REG[i] != EMPTY ||\n"
"              LOOSING.ADR_ZIP[i] != EMPTY ||\n"
"              LOOSING.ADR_COUNTRY[i] != EMPTY) {\n"
"              contained = 0;\n"
"              e = SIZE(WINNING.ADR_STREET) - 1;\n"
"              while (e >= 0) {\n"
"                 if (LOOSING.ADR_STREET[i] == WINNING.ADR_STREET[e] &&\n"
"                     LOOSING.ADR_ADDTL[i] == WINNING.ADR_ADDTL[e] &&\n"
"                     LOOSING.ADR_STREET_FLAGS[i] == WINNING.ADR_STREET_FLAGS[e] &&\n"
"                     LOOSING.ADR_POBOX[i] == WINNING.ADR_POBOX[e] &&\n"
"                     LOOSING.ADR_CITY[i] == WINNING.ADR_CITY[e] &&\n"
"                     LOOSING.ADR_REG[i] == WINNING.ADR_REG[e] &&\n"
"                     LOOSING.ADR_ZIP[i] == WINNING.ADR_ZIP[e] &&\n"
"                     LOOSING.ADR_COUNTRY[i] == WINNING.ADR_COUNTRY[e]) {\n"
"                     contained = 1;\n"
"                     break;\n"
"                 }\n"
"                 e = e - 1;\n"
"              }\n"
"              if (!contained) {\n"
"                 num = SIZE(WINNING.LABEL);\n"
"                 WINNING.ADR_STREET[num] = LOOSING.ADR_STREET[i];\n"
"                 WINNING.ADR_ADDTL[num] = LOOSING.ADR_ADDTL[i];\n"
"                 WINNING.ADR_STREET_FLAGS[num] = LOOSING.ADR_STREET_FLAGS[i];\n"
"                 WINNING.ADR_POBOX[num] = LOOSING.ADR_POBOX[i];\n"
"                 WINNING.ADR_CITY[num] = LOOSING.ADR_CITY[i];\n"
"                 WINNING.ADR_REG[num] = LOOSING.ADR_REG[i];\n"
"                 WINNING.ADR_ZIP[num] = LOOSING.ADR_ZIP[i];\n"
"                 WINNING.ADR_COUNTRY[num] = LOOSING.ADR_COUNTRY[i];\n"
"                 WINNING.LABEL[num] = LOOSING.LABEL[i];\n"
"                 winningchanged = 1;\n"
"              }\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"     }\n"
"     // Never tell the engine to update the winning client item\n"
"     // in a caching sync. The engine would send an update to the\n"
"     // client, which is not what we want when caching!\n"
"     if (!CACHEDATA() && winningchanged) { SETWINNINGCHANGED(1); }\n"
"     if (loosingchanged) { SETLOOSINGCHANGED(1); }\n"
"\n"
"     // Continue merge.\n"
"     MERGEFIELDS(mode, ignorefields);\n"
"   ]]></macro>\n"
"   <macro name=\"VCALENDAR_20TO10_PRIORITY_CONVERSION\"><![CDATA[\n"
"     //vCalendar10 has different interpretation from iCalendar20 in 'priority'.\n"
"     //see mappings:  \n"
"     //  Category      vCalendar1.0     iCalendar2.0\n"
"     //   undefined         0               0\n"
"     //   high              1             1 ~ 4\n"
"     //   normal            2               5\n"
"     //   low               3             6 ~ bigger\n"
"     if(PRIORITY<5 && PRIORITY>0) {\n"
"       PRIORITY=1;\n"
"     }else if(PRIORITY==5){\n"
"       PRIORITY=2;\n"
"     }else if(PRIORITY>5){\n"
"       PRIORITY=3;\n"
"     } // 0 is undefined and remains unchanged\n"
"   ]]></macro>\n"
"   <macro name=\"VCALENDAR_10TO20_PRIORITY_CONVERSION\"><![CDATA[\n"
"     if(PRIORITY==2) {\n"
"       PRIORITY=5;\n"
"     }else if(PRIORITY==3){\n"
"       PRIORITY=7;\n"
"     } //others remain unchanged\n"
"   ]]></macro>\n"
"   <macro name=\"VCALENDAR10_BEFOREWRITE_SCRIPT\"><![CDATA[\n"
"     $VCALENDAR_20TO10_PRIORITY_CONVERSION;\n"
"   ]]></macro>\n"
"   <macro name=\"VCALENDAR10_AFTERREAD_SCRIPT\"><![CDATA[\n"
"     $VCALENDAR_10TO20_PRIORITY_CONVERSION;\n"
"   ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_INCOMING_NAMECHANGE_SCRIPT\"><![CDATA[\n"
"      STRING tmp;\n"
"      tmp=NORMALIZED(FN);\n"
"      if (tmp==EMPTY){\n"
"        tmp=N_FIRST;\n"
"        if (N_MIDDLE != EMPTY) {\n"
"          if (tmp != EMPTY) {\n"
"            tmp = tmp + \" \";\n"
"          }\n"
"          tmp = tmp + N_MIDDLE;\n"
"        }\n"
"        if (N_LAST != EMPTY) {\n"
"          if (tmp != EMPTY) {\n"
"            tmp = tmp + \" \";\n"
"          }\n"
"          tmp = tmp + N_LAST;\n"
"        }\n"
"        FN = tmp;\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_OUTGOING_ADDREV_SCRIPT\"><![CDATA[\n"
"      if (REV==EMPTY){\n"
"        REV=\"2010-03-28T10:34:10Z\";\n"
"      }\n"
"    ]]></macro>\n"
"    <macro name=\"VCARD_OUTGOING_EMAILTYPE_SCRIPT\"><![CDATA[\n"
"        if (SESSIONVAR(\"addInternetEmail\")) {\n"
"            INTEGER i;\n"
"            i = 0;\n"
"            while (i < SIZE(EMAIL)) {\n"
"                if (EMAIL[i]) {\n"
"                    EMAIL_FLAGS[i] = EMAIL_FLAGS[i] | 8; // INTERNET = B3 in vCard profile\n"
"                }\n"
"                i = i + 1;\n"
"            }\n"
"        }\n"
"    ]]></macro>\n"
"    <function><![CDATA[\n"
"      // create a UID\n"
"      string newuid() {\n"
"        return \"syuid\" + NUMFORMAT(RANDOM(1000000),6,\"0\") + \".\" + (string)MILLISECONDS(NOW());\n"
"      }\n"
"    ]]></function>\n"
"\n"
"\n"
"    <!-- define script macros for scripts that are used by both vCalendar 1.0 and iCalendar 2.0 -->\n"
"\n"
"    <macro name=\"VCALENDAR_INCOMING_SCRIPT\"><![CDATA[\n"
"      STRING MATCHES[];\n"
"      STRING CAT,CN,EM;\n"
"      INTEGER i;\n"
"      // Remove UID/RECURRENCE-ID from servers which do not support\n"
"      // the semantic properly (for example, Funambol supports\n"
"      // UID but drops RECURRENCE-ID, causing conflicts).\n"
"      if (SESSIONVAR(\"stripUID\")) {\n"
"          UID = UNASSIGNED;\n"
"          ORIGSTART = UNASSIGNED;\n"
"      }\n"
"      // make sure we have all trailing and leading spaces eliminated\n"
"      DESCRIPTION=NORMALIZED(DESCRIPTION);\n"
"      SUMMARY=NORMALIZED(SUMMARY);\n"
"      // eliminate description that is the same as summary\n"
"      if (DESCRIPTION==SUMMARY) DESCRIPTION=EMPTY;\n"
"      // calendar or todo\n"
"      if (ISEVENT) {\n"
"        // VEVENT\n"
"        // - handle duration cases\n"
"        if (ISDURATION(DURATION)) {\n"
"          if (DTEND==EMPTY) DTEND = DTSTART + DURATION;\n"
"          if (DTSTART==EMPTY) DTSTART = DTEND - DURATION;\n"
"        }\n"
"        // - detect alldays in vCalendar 1.0 (0:00-0:00 or 23:59 localtime)\n"
"        i = ALLDAYCOUNT(DTSTART,DTEND,TRUE);\n"
"        if (ITEMDATATYPE()==\"vCalendar10\" && i>0) {\n"
"          // DTSTART and DTEND represent allday event, make them date-only values\n"
"          // - convert start to user zone (or floating) so it represents midnight\n"
"          DTSTART = CONVERTTOUSERZONE(DTSTART);\n"
"          MAKEALLDAY(DTSTART,DTEND,i);\n"
"          if (RR_END != EMPTY) {\n"
"             RR_END = DATEONLY(CONVERTTOUSERZONE(RR_END));\n"
"          }\n"
"        }\n"
"        else {\n"
"          // iCalendar 2.0 - only if DTSTART is a date-only value this really is an allday\n"
"          if (ISDATEONLY(DTSTART)) {\n"
"            // reshape to make sure we don't have invalid zero-duration alldays (old OCS 9 servers)\n"
"            MAKEALLDAY(DTSTART,DTEND,i);\n"
"          }\n"
"        }\n"
"\n"
"        // Make sure that all EXDATE times are in the same timezone as the start\n"
"        // time. Some servers send them as UTC, which is all fine and well, but\n"
"        // only if the timezone definition doesn't change. Also, libical does not\n"
"        // handle such UTC EXDATEs, so let's convert it while the UTC and\n"
"        // time zone definition (hopefully) are in sync.\n"
"        if (TIMEZONE(DTSTART) != \"UTC\" && !ISFLOATING(DTSTART)) {\n"
"          i = 0;\n"
"          timestamp exdate;\n"
"          while (i<SIZE(EXDATES)) {\n"
"            exdate = EXDATES[i];\n"
"            if (!ISDATEONLY(exdate) &&\n"
"                (TIMEZONE(exdate) == \"UTC\" || ISFLOATING(exdate))) {\n"
"              // \"unfloat\" floating time stamps: not sure whether that occcurs\n"
"              // in practice, but it looks as wrong as UTC EXDATEs\n"
"              EXDATES[i] = CONVERTTOZONE(exdate,DTSTART,TRUE);\n"
"            }\n"
"            i=i+1;\n"
"          }\n"
"        }\n"
"        // vCalendar1.0 has no VALUE=DATE EXDATEs, so convert back to that if\n"
"        // the event is all-day.\n"
"        if (ITEMDATATYPE()==\"vCalendar10\" && ISDATEONLY(DTSTART)) {\n"
"          timestamp exdate;\n"
"          i = 0;\n"
"          while (i<SIZE(EXDATES)) {\n"
"            exdate = EXDATES[i];\n"
"            if (!ISDATEONLY(exdate)) {\n"
"              exdate = CONVERTTOUSERZONE(exdate);\n"
"              EXDATES[i] = DATEONLY(exdate);\n"
"            }\n"
"            i=i+1;\n"
"          }  \n"
"        }\n"
"\n"
"        // Transform absolute alarm time back to relative time (mirrors the code in\n"
"        // VCALENDAR_OUTGOING_SCRIPT, see also BMC #11233). This applies to all\n"
"        // events, recurring or not, if the \"alarmTimeToUTC\" workaround is applied.\n"
"        // With a peer which cannot distinguish between absolute and relative\n"
"        // alarms we better treat all alarms as relative, because that is presented\n"
"        // more nicely to the user on the local side.\n"
"        if (ITEMDATATYPE()==\"vCalendar10\" &&\n"
"            ALARM_TIME!=EMPTY &&\n"
"            !ISDURATION(ALARM_TIME) &&\n"
"            SESSIONVAR(\"alarmTimeToUTC\")) { \n"
"            ALARM_TIME = ALARM_TIME - DTSTART;\n"
"        }\n"
"\n"
"        // - shape attendees (and make sure ATTENDEES[] is assigned even for empty email addresses)\n"
"        i=0;\n"
"        while(i<SIZE(ATTENDEES) || i<SIZE(ATTENDEE_CNS)) {\n"
"          PARSEEMAILSPEC(ATTENDEES[i], CN, EM);\n"
"          ATTENDEES[i] = EM; // pure email address\n"
"          // in case we have no specific common name, use the one extracted from the email\n"
"          // This catches the vCalendar 1.0 case and eventually ill-formed iCalendar 2.0 as well\n"
"          if (ATTENDEE_CNS[i]==EMPTY)\n"
"            ATTENDEE_CNS[i]=CN;\n"
"          // default participation status to needs-action\n"
"          if (ATTENDEE_PARTSTATS[i]==EMPTY)\n"
"            ATTENDEE_PARTSTATS[i]=1; // 1=needs action\n"
"          i=i+1;\n"
"        }\n"
"        // - shape organizer\n"
"        PARSEEMAILSPEC(ORGANIZER, CN, EM);\n"
"        ORGANIZER = EM; // pure email address\n"
"        if (ORGANIZER_CN==EMPTY)\n"
"          ORGANIZER_CN=CN;\n"
"      }\n"
"      else {\n"
"        // VTODO\n"
"        // - make sure we have at least a summary\n"
"        if (SUMMARY==EMPTY) SUMMARY=DESCRIPTION; // use description if we don't have a summary\n"
"        if (SUMMARY==EMPTY) SUMMARY=\"unnamed\"; // set dummy summary if we still don't have one\n"
"        // due shaping for non-iCalendar 2.0\n"
"        if (ITEMDATATYPE()==\"vCalendar10\" && ALLDAYCOUNT(DUE,DUE,TRUE,TRUE)>0) {\n"
"          DUE = CONVERTTOUSERZONE(DUE);\n"
"          DUE = DATEONLY(DUE);\n"
"        }\n"
"        if (ITEMDATATYPE()==\"vCalendar10\") {\n"
"          $VCALENDAR_10TO20_PRIORITY_CONVERSION;\n"
"        }\n"
"      }\n"
"      // a workaround for funambol: adding 'action' for 'alarm'\n"
"      // if item data type is vCalendar1.0, also add 'action' for 'alarm'.\n"
"      // This is a workaround for Mobical.net, which uses vCalendar1.0.\n"
"      if (ALARM_TIME!=EMPTY && ALARM_ACTION==EMPTY) {\n"
"          ALARM_ACTION = \"DISPLAY\";\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"\n"
"    <macro name=\"VCALENDAR_OUTGOING_SCRIPT\"><![CDATA[\n"
"      // set UTC time of generation for iCalendar 2.0 DTSTAMP\n"
"      DGENERATED = NOW();\n"
"      // make sure we have all trailing and leading spaces eliminated\n"
"      DESCRIPTION=NORMALIZED(DESCRIPTION);\n"
"      SUMMARY=NORMALIZED(SUMMARY);\n"
"      if (ISEVENT) {\n"
"        // VEVENT\n"
"        // - combine attendee email address and common name into single string for vCalendar 1.0\n"
"        if (ITEMDATATYPE()==\"vCalendar10\") {\n"
"          i=0;\n"
"          while(i<SIZE(ATTENDEES)) {\n"
"            ATTENDEES[i] = MAKEEMAILSPEC(ATTENDEE_CNS[i], ATTENDEES[i]);\n"
"            i=i+1;\n"
"          }\n"
"          ORGANIZER = MAKEEMAILSPEC(ORGANIZER_CN, ORGANIZER);\n"
"        }\n"
"      }\n"
"      else {\n"
"        // VTODO \n"
"        // interal representation is iCalendar20\n"
"        if (ITEMDATATYPE()==\"vCalendar10\") {\n"
"          $VCALENDAR_20TO10_PRIORITY_CONVERSION;\n"
"        }\n"
"      }\n"
"      // make sure we have at least a summary\n"
"      if (SUMMARY==EMPTY) SUMMARY=SUBSTR(DESCRIPTION,0,32); // derive from description\n"
"      if (SUMMARY==EMPTY) SUMMARY=\"unnamed\"; // in case description is empty as well\n"
"      // make sure that we have a DESCRIPTION, because some peers only support that;\n"
"      // can be avoided for peers where we are certain (from CtCaps) that they can\n"
"      // receive the text as part of the summary; don't do this for VJOURNAL\n"
"      if (ISAVAILABLE(SUMMARY)!=TRUE && DESCRIPTION==EMPTY && ISEVENT != 2) DESCRIPTION=SUMMARY;\n"
"      // do NOT send duration (some servers crash when doing so)\n"
"      DURATION = UNASSIGNED;\n"
"      // shape alarm\n"
"      if (ALARM_TIME!=EMPTY) {\n"
"        if (ITEMDATATYPE()==\"iCalendar20\") {\n"
"          if (ALARM_ACTION==EMPTY) ALARM_ACTION = \"AUDIO\";\n"
"        }\n"
"        else {\n"
"          if (ALARM_MSG==EMPTY) ALARM_MSG=\"alarm\";\n"
"        }\n"
"      }\n"
"\n"
"      // for 'ALARM_TIME', convert duration time to UTC time\n"
"      // This workaround is for Mobical.net which can't understand duration time.\n"
"      // Also used with phones. The interpretation at least by Nokia\n"
"      // is that the absolute alarm time repeats together with the\n"
"      // event (BMC #11233). VCALENDAR_INCOMING_SCRIPT has the\n"
"      // corresponding transformation back (important for recurring events).\n"
"      if (SESSIONVAR(\"alarmTimeToUTC\") && ITEMDATATYPE()==\"vCalendar10\"\n"
"            && ALARM_TIME!=EMPTY && ISDURATION(ALARM_TIME)) {\n"
"        TIMESTAMP ts;\n"
"        if (ALARM_REL==2)\n"
"          ts = DTEND; // relative to end\n"
"        else {\n"
"          if (ISEVENT)\n"
"            ts = DTSTART; // relative to start for events\n"
"          else\n"
"            ts = DUE; // relative to due for todos\n"
"        }\n"
"\n"
"        ALARM_TIME = CONVERTTOUSERZONE(POINTINTIME(ts), TRUE) + ALARM_TIME;\n"
"        ALARM_TIME = CONVERTTOZONE(ALARM_TIME, \"UTC\");\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"FIX_EXDATE_SCRIPT\"><![CDATA[\n"
"      // Add time zone information to EXDATEs: necessary for\n"
"      // the Maemo calendar storages because it uses EXDATE\n"
"      // without TZID.\n"
"      if (!ISFLOATING(DTSTART)) {\n"
"        STRING tz;\n"
"        tz = TIMEZONE(DTSTART);\n"
"        if (tz != \"UTC\") {\n"
"          INTEGER i;\n"
"          i = 0;\n"
"          while (i<SIZE(EXDATES)) {\n"
"            if (ISFLOATING(EXDATES[i])) {\n"
"              SETTIMEZONE(EXDATES[i], tz);\n"
"            }\n"
"            i=i+1;\n"
"          }\n"
"        }\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <!-- Uses the UID/RECURRENCE-ID fields as the only criteria for\n"
"         comparing calendar data if the parameter $1 (see GLOBALIDS in <initscript>)\n"
"         is true, else does a normal comparison of the\n"
"         fields. That comparison is based on the datatype definition\n"
"         and ignores UID because it is not trusted to be\n"
"         preserved and/or implemented by peers.\n"
"\n"
"         In case of a UID match, the DMODIFIED fields are compared\n"
"         to determine the older item.\n"
"    -->\n"
"    <macro name=\"VCALENDAR_COMPARE_SCRIPT\"><![CDATA[\n"
"    INTEGER RES;\n"
"    if (COMPARISONMODE() != \"age\" && SYNCMODESUPPORTED(\"1122583000\")) {\n"
"        if (TARGET.UID == REFERENCE.UID &&\n"
"            TARGET.ORIGSTART == REFERENCE.ORIGSTART) {\n"
"            RES = 0;\n"
"        } else {\n"
"            RES = -999;\n"
"        }\n"
"    } else {\n"
"        RES = COMPAREFIELDS();\n"
"    }\n"
"    return RES;\n"
"    ]]></macro>\n"
"\n"
"    <!-- invoked when reading plain text memo from storage or receiving from peer -->\n"
"    <macro name=\"MEMO_INCOMING_SCRIPT\"><![CDATA[\n"
"    ISEVENT = 2;\n"
"\n"
"    // Copy summary into description. It is not 100% certain whether that is\n"
"    // necessary (the summary might be completely unrelated to the description text),\n"
"    // but this way it is consistent with the way how the EDS backend used to handle\n"
"    // it and symmetric with MEMO_OUTGOING_SCRIPT.\n"
"    if (SUMMARY != EMPTY && DESCRIPTION != EMPTY) {\n"
"        DESCRIPTION = SUMMARY + \"\\n\" + DESCRIPTION;\n"
"    }\n"
"    ]]></macro>\n"
"\n"
"    <!-- invoked before writing plain text memo into storage or sending to peer -->\n"
"    <macro name=\"MEMO_OUTGOING_SCRIPT\"><![CDATA[\n"
"    // remove SUMMARY from start of DESCRIPTION before writing if text matches,\n"
"    // because sending as plain text will concatenate them again\n"
"    integer lensummary, lendescr;\n"
"    lensummary = LENGTH(SUMMARY);\n"
"    lendescr = LENGTH(DESCRIPTION);\n"
"    if (lendescr >= lensummary &&\n"
"        SUBSTR(DESCRIPTION, 0, lensummary) == SUMMARY &&\n"
"        (lensummary == lendescr || SUBSTR(DESCRIPTION, lensummary, 1) == \"\\n\")) {\n"
"        DESCRIPTION = SUBSTR(DESCRIPTION, lensummary + 1, lendescr - lensummary - 1);\n"
"    }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"CALENDAR_BEFOREWRITE_SCRIPT\"><![CDATA[\n"
"      if (UID == EMPTY) { UID = newuid(); }\n"
"\n"
"      // set UTC time of generation for iCalendar 2.0 DTSTAMP\n"
"      DGENERATED = NOW();\n"
"      // ensure that there is a DMODIFIED = LAST-MODIFIED property,\n"
"      // not all storages add it\n"
"      if (!DMODIFIED) {\n"
"         DMODIFIED = DGENERATED;\n"
"      }\n"
"    ]]></macro>\n"
"    <macro name=\"VCARD_BEFOREWRITE_SCRIPT\"><![CDATA[\n"
"      if (UID == EMPTY) { UID = newuid(); }\n"
"      $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT;\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"NEWTAG\"><![CDATA[\n"
"      INTEGER newtag;\n"
"      newtag = 1;\n"
"      while (TRUE) {\n"
"         $1 = \"item\" + newtag;\n"
"         if (!CONTAINS($2, $1)) {\n"
"            break;\n"
"         }\n"
"         newtag = newtag + 1;\n"
"      }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_AFTERREAD_SCRIPT\"><![CDATA[\n"
"      $VCARD_INCOMING_PHOTO_VALUE_SCRIPT;\n"
"    ]]></macro>\n"
"\n"
"    <!-- moves an IMPP value to a specific legacy field -->\n"
"    <macro name=\"VCARD_MODERN_TO_LEGACY_IMPP\"><![CDATA[\n"
"       INTEGER impp_index;\n"
"       impp_index = SIZE($2);\n"
"       SWAP($1, $2[impp_index]);\n"
"       SWAP(IMPP_SLOT[$4], $3[impp_index]);\n"
"       IMPP[$4] = UNASSIGNED;\n"
"    ]]></macro>\n"
"\n"
"    <!-- convert from IMPP to X- fields, XDATE to ANNIVERSARY, etc. -->\n"
"    <macro name=\"VCARD_MODERN_TO_LEGACY\"><![CDATA[\n"
"       INTEGER i;\n"
"       STRING s;\n"
"\n"
"       // Special X-ABDATE -> X-ANNIVERSARY.\n"
"       i = SIZE(XDATE) - 1;\n"
"       while (i >= 0) {\n"
"          if (GROUP_TAG[i] != EMPTY &&\n"
"              XDATE[i] != UNASSIGNED &&\n"
"              LABEL[i] == \"Anniversary\") {\n"
"              SWAP(ANNIVERSARY, XDATE[i]);\n"
"\n"
"              // XDATE[i] = UNASSIGNED;\n"
"              break;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       // Special X-ABRELATEDNAMES -> X-SPOUSE/MANAGER/ASSISTANT\n"
"       i = SIZE(RELATEDNAMES) - 1;\n"
"       while (i >= 0) {\n"
"          if (GROUP_TAG[i] != EMPTY &&\n"
"              RELATEDNAMES[i] != UNASSIGNED) {\n"
"             s = LABEL[i];\n"
"             if (s == \"Spouse\") {\n"
"                if (SPOUSE == EMPTY) {\n"
"                   SWAP(SPOUSE, RELATEDNAMES[i]);\n"
"                   // RELATEDNAMES[i] = UNASSIGNED;\n"
"                }\n"
"             } else if (s == \"Manager\") {\n"
"                if (MANAGER == EMPTY) {\n"
"                   SWAP(MANAGER, RELATEDNAMES[i]);\n"
"                   // RELATEDNAMES[i] = UNASSIGNED;\n"
"                }\n"
"             } else if (s == \"Assistant\") {\n"
"                if (ASSISTANT == EMPTY) {\n"
"                   SWAP(ASSISTANT, RELATEDNAMES[i]);\n"
"                   // RELATEDNAMES[i] = UNASSIGNED;\n"
"                }\n"
"             }\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       // IMPP -> X-JABBER/AIM/... depending on service type. Protocol must match.\n"
"       i = SIZE(IMPP) - 1;\n"
"       INTEGER offset;\n"
"       STRING service;\n"
"       STRING protocol;\n"
"       STRING value;\n"
"       while (i >= 0) {\n"
"          service = IMPP_SERVICE[i];\n"
"          if (service != UNASSIGNED) {\n"
"             offset = FIND(IMPP[i], \":\");\n"
"             if (offset != UNASSIGNED) {\n"
"                protocol = SUBSTR(IMPP[i], 0, offset);\n"
"                value = URLDECODE(SUBSTR(IMPP[i], offset + 1));\n"
"                if (service == \"AIM\" && protocol == \"aim\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, AIM_HANDLE, AIM_SLOT, i);\n"
"                } else if (service == \"Gadugadu\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, GADUGADU_HANDLE, GADUGADU_SLOT, i);\n"
"                } else if (service == \"Groupwise\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, GROUPWISE_HANDLE, GROUPWISE_SLOT, i);\n"
"                } else if (service == \"ICQ\" && protocol == \"aim\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, ICQ_HANDLE, ICQ_SLOT, i);\n"
"                } else if (service == \"Jabber\" && protocol == \"xmpp\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, JABBER_HANDLE, JABBER_SLOT, i);\n"
"                } else if (service == \"MSN\" && protocol == \"msnim\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, MSN_HANDLE, MSN_SLOT, i);\n"
"                } else if (service == \"Yahoo\" && protocol == \"ymsgr\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, YAHOO_HANDLE, YAHOO_SLOT, i);\n"
"                } else if (service == \"Skype\" && protocol == \"skype\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, SKYPE_HANDLE, SKYPE_SLOT, i);\n"
"                } else if (service == \"Sip\") {\n"
"                   $VCARD_MODERN_TO_LEGACY_IMPP(value, SIP_HANDLE, SIP_SLOT, i);\n"
"                }\n"
"             }\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"\n"
"       // Remove labels which are no longer needed (valued moved above,\n"
"       // stored for a group which has no other properties (Google\n"
"       // CardDAV server sometimes sends that, editing in Evolution\n"
"       // might cause it, etc.) or provide no information (\"Other\").\n"
"       i = SIZE(LABEL) - 1;\n"
"       while (i >= 0) {\n"
"          if (LABEL[i] == \"Other\" ||\n"
"              LABEL[i] != UNASSIGNED &&\n"
"              (GROUP_TAG[i] == EMPTY ||\n"
"               RELATEDNAMES[i] == UNASSIGNED &&\n"
"               XDATE[i] == UNASSIGNED &&\n"
"               TEL[i] == UNASSIGNED &&\n"
"               EMAIL[i] == UNASSIGNED &&\n"
"               WEB[i] == UNASSIGNED &&\n"
"               XDATE[i] == UNASSIGNED &&\n"
"               IMPP[i] == UNASSIGNED &&\n"
"               ADR_POBOX[i] == UNASSIGNED &&\n"
"               ADR_ADDTL[i] == UNASSIGNED &&\n"
"               ADR_STREET[i] == UNASSIGNED &&\n"
"               ADR_CITY[i] == UNASSIGNED &&\n"
"               ADR_REG[i] == UNASSIGNED &&\n"
"               ADR_ZIP[i] == UNASSIGNED &&\n"
"               ADR_COUNTRY[i] == UNASSIGNED &&\n"
"               ADR_STREET_FLAGS[i] == UNASSIGNED)) {\n"
"               LABEL[i] = UNASSIGNED;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"\n"
"       // Remove all group tags. Not used for legacy formats.\n"
"       GROUP_TAG = UNASSIGNED;\n"
"    ]]></macro>\n"
"\n"
"    <!-- The legacy->modern conversion ignores empty property values\n"
"    because we would not encode them as empty\n"
"    IMPP/X-ABDATE/X-ABRELATEDNAMES values anyway\n"
"    (<noemptyproperties>), leaving us with just the redundant labels.\n"
"    -->\n"
"\n"
"    <!-- X-SPOUSE/MANAGER/ASSISTANT -> special X-ABRELATEDNAMES -->\n"
"    <macro name=\"VCARD_LEGACY_TO_MODERN_RELATEDNAMES\"><![CDATA[\n"
"       if ($1 != EMPTY) {\n"
"          // STRING tag;\n"
"          INTEGER num;\n"
"          num = SIZE(LABEL);\n"
"          // $NEWTAG(tag, GROUP_TAG);\n"
"          SWAP(RELATEDNAMES[num], $1);\n"
"          LABEL[num] = $2;\n"
"          // GROUP_TAG[num] = tag;\n"
"          // $1 = UNASSIGNED;\n"
"       }\n"
"    ]]></macro>\n"
"\n"
"    <!-- X-JABBER/AIM/... -> IMPP -->\n"
"    <macro name=\"VCARD_LEGACY_TO_MODERN_IMPP\"><![CDATA[\n"
"       INTEGER impp_index;\n"
"       impp_index = SIZE($3) - 1;\n"
"       while (impp_index >= 0) {\n"
"          if ($3[impp_index] != EMPTY) {\n"
"             INTEGER num;\n"
"             num = SIZE(LABEL);\n"
"             IMPP[num] = $2 + \":\" + URLENCODE($3[impp_index]);\n"
"             $3[impp_index] = UNASSIGNED;\n"
"             SWAP($4[impp_index], IMPP_SLOT[num]);\n"
"             IMPP_SERVICE[num] = $1;\n"
"             LABEL[num] = \"Other\";\n"
"          }\n"
"          impp_index = impp_index - 1;\n"
"       }\n"
"    ]]></macro>\n"
"\n"
"    <!-- convert from X- fields to IMPP, ANNIVERSARY to DATE, etc. -->\n"
"    <macro name=\"VCARD_LEGACY_TO_MODERN\"><![CDATA[\n"
"       if (ANNIVERSARY != EMPTY) {\n"
"          INTEGER i;\n"
"          i = SIZE(LABEL);\n"
"          // STRING tag;\n"
"\n"
"          // $NEWTAG(tag, GROUP_TAG);\n"
"\n"
"          SWAP(XDATE[i], ANNIVERSARY);\n"
"          LABEL[i] = \"Anniversary\";\n"
"          // GROUP_TAG[i] = tag;\n"
"          // ANNIVERSARY = UNASSIGNED;\n"
"       }\n"
"\n"
"       $VCARD_LEGACY_TO_MODERN_RELATEDNAMES(SPOUSE, \"Spouse\");\n"
"       $VCARD_LEGACY_TO_MODERN_RELATEDNAMES(MANAGER, \"Manager\");\n"
"       $VCARD_LEGACY_TO_MODERN_RELATEDNAMES(ASSISTANT, \"Assistant\");\n"
"\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"AIM\", \"aim\", AIM_HANDLE, AIM_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Gadugadu\", \"x-apple\", GADUGADU_HANDLE, GADUGADU_SLOT); // ???\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Groupwise\", \"x-apple\", GROUPWISE_HANDLE, GROUPWISE_SLOT); // ???\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"ICQ\", \"aim\", ICQ_HANDLE, ICQ_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Jabber\", \"xmpp\", JABBER_HANDLE, JABBER_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"MSN\", \"msnim\", MSN_HANDLE, MSN_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Yahoo\", \"ymsgr\", YAHOO_HANDLE, YAHOO_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Skype\", \"skype\", SKYPE_HANDLE, SKYPE_SLOT);\n"
"       $VCARD_LEGACY_TO_MODERN_IMPP(\"Sip\", \"x-apple\", SIP_HANDLE, SIP_SLOT); // ???\n"
"       // $VCARD_LEGACY_TO_MODERN_IMPP(\"???\", \"???\", IM_ADDRESS);\n"
"       // $VCARD_LEGACY_TO_MODERN_IMPP(\"???\", \"???\", MEANWHILE_HANDLE, MEANWHILE_SLOT);\n"
"       // $VCARD_LEGACY_TO_MODERN_IMPP(\"??\", \"???\", SMS_HANDLE, SMS_SLOT);\n"
"\n"
"       // Create group tags for all labels. Without them the label won't be\n"
"       // associated with the corresponding property in the modern vCard.\n"
"       INTEGER i;\n"
"       i = SIZE(LABEL) - 1;\n"
"       // Reset GROUP_TAG. It might contain obsolete tags after\n"
"       // a read/modify cycle.\n"
"       GROUP_TAG = EMPTY;\n"
"       // We don't use group tags internally, so we can simply enumerate them\n"
"       // here.\n"
"       INTEGER tagnum;\n"
"       tagnum = 1;\n"
"       while (i >= 0) {\n"
"          if (LABEL[i] != EMPTY) {\n"
"             GROUP_TAG[i] = \"item\" + tagnum;\n"
"             tagnum = tagnum + 1;\n"
"          }\n"
"          i = i - 1;\n"
"       }\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_BEFOREWRITE_SCRIPT_WEBDAV\"><![CDATA[\n"
"      $VCARD_BEFOREWRITE_SCRIPT;\n"
"      $VCARD_LEGACY_TO_MODERN;\n"
"    ]]></macro>\n"
"\n"
"    <macro name=\"VCARD_AFTERREAD_SCRIPT_WEBDAV\"><![CDATA[\n"
"      $VCARD_MODERN_TO_LEGACY;\n"
"      $VCARD_AFTERREAD_SCRIPT;\n"
"    ]]></macro>\n"
"  </scripting>\n"
"\n"
"  <datatypes>\n"
"    <!-- list of internal fields representing vCard data -->\n"
"    <fieldlist name=\"contacts\">\n"
"      <field name=\"SYNCLVL\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"REV\" type=\"timestamp\" compare=\"never\" age=\"yes\"/>\n"
"\n"
"      <!-- If we knew that both sides have reliable UID support, we could use\n"
"       it for pairing. But we don't know that and thus cannot rely on it. -->\n"
"      <field name=\"UID\" type=\"string\" compare=\"never\"/>\n"
"\n"
"      <!-- The group tags used to combine instances of different repeating properties. -->\n"
"      <field name=\"GROUP_TAG\" array=\"yes\" type=\"string\" compare=\"never\"/>\n"
"\n"
"      <!-- Name elements -->\n"
"      <field name=\"N_LAST\" type=\"string\" compare=\"always\"/>\n"
"      <field name=\"N_FIRST\" type=\"string\" compare=\"always\"/>\n"
"      <field name=\"N_MIDDLE\" type=\"string\" compare=\"always\"/>\n"
"      <field name=\"N_PREFIX\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"N_SUFFIX\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"NICKNAME\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"TITLE\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <field name=\"FN\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"FILE_AS\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <field name=\"GENDER\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- categories and classification -->\n"
"      <field name=\"CATEGORIES\" array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- organisation -->\n"
"      <field name=\"ORG_NAME\" type=\"string\" compare=\"slowsync\" merge=\"fillempty\"/>\n"
"      <field name=\"ORG_DIVISION\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"ORG_OFFICE\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"ORG_TEAM\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"ROLE\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- Birthday and anniversary (not necessarily the same). BDAY is always used,\n"
"           ANNIVERSARY only by some profiles. -->\n"
"      <field name=\"BDAY\" type=\"date\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"ANNIVERSARY\" type=\"date\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- Generic storage for special dates, including anniversary. Mapped to X-ABDATE + X-ABLabel. -->\n"
"      <!-- Beware, don't use \"DATE\", it conflicts with builtin function name. -->\n"
"      <field name=\"XDATE\" array=\"yes\" type=\"date\" compare=\"conflict\"/>\n"
"\n"
"      <!-- telephone numbers -->\n"
"      <field name=\"TEL\"         array=\"yes\" type=\"telephone\" compare=\"conflict\"/>\n"
"      <field name=\"TEL_FLAGS\"   array=\"yes\" type=\"integer\"   compare=\"conflict\"/>\n"
"      <field name=\"TEL_SLOT\"    array=\"yes\" type=\"integer\"   compare=\"never\"/>\n"
"\n"
"      <!-- emails -->\n"
"      <field name=\"EMAIL\"       array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"EMAIL_FLAGS\" array=\"yes\" type=\"integer\"   compare=\"conflict\"/>\n"
"      <field name=\"EMAIL_SLOT\"  array=\"yes\" type=\"integer\"   compare=\"never\"/>\n"
"\n"
"      <!-- web addresses -->\n"
"      <field name=\"WEB\"         array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"WEB_FLAGS\"   array=\"yes\" type=\"integer\"   compare=\"conflict\"/>\n"
"\n"
"      <!-- would be nicer to have as part of WEB, but parser/encoder does not support mapping\n"
"           with more than one property per field -->\n"
"      <field name=\"CALURI\"      array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"FBURL\"       array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"BLOGURL\"     array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"VIDEOURL\"    array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- generic replacement for MANAGER/ASSISTANT/SPOUSE -->\n"
"      <field name=\"RELATEDNAMES\" array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- related persons: should be turned into array, like WEB and CALURI/FBURL -->\n"
"      <field name=\"MANAGER\"    type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ASSISTANT\"  type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SPOUSE\"     type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- does this person want HTML mails? Valid values are TRUE/FALSE; a \"boolean\"\n"
"           type would be useful, maybe add that later. -->\n"
"      <field name=\"WANTS_HTML\"  type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- RFC 4770 chat handles, used internally *instead* of the individual handles below. -->\n"
"      <field name=\"IMPP\" array=\"yes\" type=\"string\" compare=\"conflict\"/> <!-- includes protocol: xmpp:google%20talk -->\n"
"      <field name=\"IMPP_SERVICE\" array=\"yes\" type=\"string\" compare=\"conflict\"/> <!-- GoogleTalk -->\n"
"      <field name=\"IMPP_SLOT\" array=\"yes\" type=\"string\" compare=\"conflict\"/> <!-- Evolution UI slot -->\n"
"\n"
"      <!-- Individual chat handles: used as temporary storage when exchanging data via legacy profiles. -->\n"
"      <field name=\"AIM_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"AIM_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"GADUGADU_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"GADUGADU_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"GROUPWISE_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"GROUPWISE_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ICQ_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ICQ_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"JABBER_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"JABBER_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"MSN_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"MSN_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"YAHOO_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"YAHOO_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SKYPE_HANDLE\"      array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SKYPE_SLOT\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SIP_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SIP_SLOT\"          array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"IM_ADDRESS\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"MEANWHILE_HANDLE\"  array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"IRC_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"SMS_HANDLE\"        array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- home address -->\n"
"      <field name=\"ADR_STREET\"        array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_ADDTL\"         array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_STREET_FLAGS\"  array=\"yes\" type=\"integer\"   compare=\"conflict\"/>\n"
"      <field name=\"ADR_POBOX\"         array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_CITY\"          array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_REG\"           array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_ZIP\"           array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"      <field name=\"ADR_COUNTRY\"       array=\"yes\" type=\"multiline\" compare=\"conflict\"/>\n"
"\n"
"      <!-- Note -->\n"
"      <field name=\"NOTE\" type=\"multiline\" compare=\"conflict\" merge=\"lines\"/>\n"
"\n"
"      <!-- Photo -->\n"
"      <field name=\"PHOTO\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"PHOTO_TYPE\" type=\"string\" compare=\"never\" merge=\"fillempty\"/>\n"
"      <field name=\"PHOTO_VALUE\" type=\"string\" compare=\"never\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- Location -->\n"
"      <field name=\"GEO_LAT\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"GEO_LONG\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- Crypto fields for KAddressbook -->\n"
"      <field name=\"CRYPTOENCRYPTPREF\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"CRYPTOPROTOPREF\" array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"CRYPTOSIGNPREF\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"OPENPGPFP\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- Custom labels. Mapped to either X-ABProperty via group tag (WebDAV) or X-ABLabel parameter (internal). -->\n"
"      <field name=\"LABEL\" array=\"yes\" type=\"string\" compare=\"conflict\"/>\n"
"\n"
"      <!-- store extensions that don't match any of the other fields -->\n"
"      <field name=\"XPROPS\" array=\"yes\" type=\"string\" compare=\"never\"/>\n"
"    </fieldlist>\n"
"    <!-- vCard profile for Evolution, KDE, SyncML -->\n"
"    <mimeprofile name=\"vCard\" fieldlist=\"contacts\">\n"
"\n"
"      <profile name=\"VCARD\" nummandatory=\"0\"> <!-- we allow records without \"N\" as Address book can store them -->\n"
"        <property name=\"VERSION\">\n"
"          <value conversion=\"version\"/>\n"
"        </property>\n"
"\n"
"        <property onlyformode=\"standard\" name=\"PRODID\" mandatory=\"no\">\n"
"          <value conversion=\"prodid\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"REV\" rule=\"EXTENDED-DATE-FORMAT\" mandatory=\"yes\">\n"
"          <value field=\"REV\" conversion=\"DATE+EXTFMT\"/>\n"
"        </property>\n"
"        <property name=\"REV\" rule=\"other\" mandatory=\"yes\">\n"
"          <value field=\"REV\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"UID\" rule=\"HAVE-VCARD-UID\" showindevinf=\"no\">\n"
"          <value field=\"UID\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"N\" values=\"5\" mandatory=\"yes\"> <!-- Note: makes N parse and generate even if not in remote's CTCap -->\n"
"          <value index=\"0\" field=\"N_LAST\"/>\n"
"          <value index=\"1\" field=\"N_FIRST\"/>\n"
"          <value index=\"2\" field=\"N_MIDDLE\"/>\n"
"          <value index=\"3\" field=\"N_PREFIX\"/>\n"
"          <value index=\"4\" field=\"N_SUFFIX\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"FN\">\n"
"          <value field=\"FN\"/>\n"
"        </property>\n"
"\n"
"        <!-- FILE_AS not supported by KDE natively, let's use X-EVOLUTION-FILE-AS as extension -->\n"
"        <property name=\"X-EVOLUTION-FILE-AS\">\n"
"          <value field=\"FILE_AS\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-GENDER\">\n"
"          <value field=\"GENDER\"/>\n"
"        </property>\n"
"\n"
"        <!-- onlyformode=\"standard\": not part of vCard 2.1, but some\n"
"             peers (like the Funambol server) accept it anyway in\n"
"             vCard 2.1 -->\n"
"        <property name=\"NICKNAME\">\n"
"          <value field=\"NICKNAME\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"TITLE\">\n"
"          <value field=\"TITLE\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"CATEGORIES\" values=\"list\" valueseparator=\",\" altvalueseparator=\";\" > <!-- non-standard, but 1:1 as in vCard 3.0 (NOT like in vCalendar 1.0, where separator is \";\") -->\n"
"          <value field=\"CATEGORIES\"/>\n"
"          <position field=\"CATEGORIES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <!-- ORG property for KDE *and* everyone else; KDE *also* uses X-KADDRESSBOOK-X-Office -->\n"
"        <property name=\"ORG\" values=\"4\">\n"
"          <value index=\"0\" field=\"ORG_NAME\"/>\n"
"          <value index=\"1\" field=\"ORG_DIVISION\"/>\n"
"          <value index=\"2\" field=\"ORG_OFFICE\"/>\n"
"          <value index=\"3\" field=\"ORG_TEAM\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-Office\" suppressempty=\"yes\" rule=\"KDE\">\n"
"          <value field=\"ORG_OFFICE\"/>\n"
"        </property>\n"
"\n"
"        <!-- X-KADDRESSBOOK-X-Profession property for KDE, ROLE for everyone else -->\n"
"        <property name=\"ROLE\" rule=\"KDE\"/>\n"
"        <property name=\"ROLE\" rule=\"other\">\n"
"          <value field=\"ROLE\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-Profession\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"ROLE\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"TEL\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"TEL\"/>\n"
"          <position field=\"TEL\" repeat=\"array\" increment=\"1\" minshow=\"1\"/>\n"
"          <parameter name=\"TYPE\" default=\"yes\" positional=\"no\" show=\"yes\">\n"
"            <value field=\"TEL_FLAGS\" conversion=\"multimix\" combine=\",\">\n"
"              <enum name=\"HOME\"     value=\"B0\"/>\n"
"              <enum name=\"WORK\"     value=\"B1\"/>\n"
"              <enum mode=\"ignore\"   value=\"B2\"/> <!-- OTHER -->\n"
"              <enum name=\"VOICE\"    value=\"B3\"/>\n"
"              <enum name=\"CELL\"     value=\"B4\"/>\n"
"              <enum name=\"FAX\"      value=\"B5\"/>\n"
"              <enum name=\"PAGER\"    value=\"B6\"/>\n"
"              <enum name=\"PREF\"     value=\"B7\"/>\n"
"              <enum name=\"CAR\"      value=\"B8\"/>\n"
"              <enum name=\"X-EVOLUTION-CALLBACK\" value=\"B9\"/>\n"
"              <enum name=\"X-EVOLUTION-RADIO\" value=\"B10\"/>\n"
"              <enum name=\"X-EVOLUTION-TELEX\" value=\"B11\"/>\n"
"              <enum name=\"X-EVOLUTION-TTYTDD\" value=\"B12\"/>\n"
"            </value>\n"
"          </parameter>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"TEL_SLOT\"/>\n"
"          </parameter>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"EMAIL\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"EMAIL\"/>\n"
"          <position field=\"EMAIL\" repeat=\"array\" increment=\"1\" minshow=\"1\"/>\n"
"          <parameter name=\"TYPE\" default=\"yes\" positional=\"no\" show=\"yes\">\n"
"            <value field=\"EMAIL_FLAGS\" conversion=\"multimix\" combine=\",\">\n"
"              <enum name=\"HOME\"     value=\"B0\"/>\n"
"              <enum name=\"WORK\"     value=\"B1\"/>\n"
"              <enum mode=\"ignore\"   value=\"B2\"/> <!-- OTHER -->\n"
"              <enum name=\"INTERNET\" value=\"B3\"/>\n"
"            </value>\n"
"          </parameter>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"EMAIL_SLOT\"/>\n"
"          </parameter>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"URL\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"WEB\"/>\n"
"          <position field=\"WEB\" repeat=\"array\" increment=\"1\" minshow=\"1\"/>\n"
"          <parameter name=\"TYPE\" default=\"yes\" positional=\"no\" show=\"yes\">\n"
"            <value field=\"WEB_FLAGS\" conversion=\"multimix\" combine=\",\">\n"
"              <enum name=\"HOME\"     value=\"B0\"/>\n"
"              <enum name=\"WORK\"     value=\"B1\"/>\n"
"              <enum mode=\"ignore\"   value=\"B2\"/> <!-- OTHER -->\n"
"              <enum name=\"PREF\"     value=\"B3\"/>\n"
"            </value>\n"
"          </parameter>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"CALURI\" suppressempty=\"yes\">\n"
"          <value field=\"CALURI\"/>\n"
"        </property>\n"
"        <property name=\"FBURL\" suppressempty=\"yes\">\n"
"          <value field=\"FBURL\"/>\n"
"        </property>\n"
"\n"
"        <!-- X-EVOLUTION-BLOG-URL property for everyone except KDE -->\n"
"        <property name=\"X-EVOLUTION-BLOG-URL\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-EVOLUTION-BLOG-URL\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"BLOGURL\"/>\n"
"        </property>\n"
"        <!-- the KDE way of expressing BLOGURL -->\n"
"        <property name=\"X-KADDRESSBOOK-BlogFeed\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"BLOGURL\"/>\n"
"        </property>\n"
"\n"
"        <!-- VIDEOURL not supported by KDE natively, let's use X-EVOLUTION-VIDEO-URL as extension -->\n"
"        <property name=\"X-EVOLUTION-VIDEO-URL\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"VIDEOURL\"/>\n"
"        </property>\n"
"\n"
"        <!-- item for SyncML server: EVOLUTION rule not active,\n"
"             both X-EVOLUTION-MANAGER and X-MANAGER are sent.\n"
"\n"
"             item from SyncML server: EVOLUTION rule not active,\n"
"             both X-EVOLUTION-MANAGER and X-MANAGER are checked,\n"
"             but X-EVOLUTION-MANAGER later so that it overwrites\n"
"             a value set earlier by X-MANAGER (if any). This is\n"
"             a more or less arbitrary priority, chosen because\n"
"             servers that know about SyncEvolution (ScheduleWorld,\n"
"             Memotoo) use the X-EVOLUTION variant.\n"
"\n"
"             item to/from Evolution: EVOLUTION rule is active,\n"
"             only X-EVOLUTION-MANAGER is used.\n"
"\n"
"             item to/from KDE: the X-EVOLUTION extensions are disabled,\n"
"             only exchanged via KDE-only extensions\n"
"        -->\n"
"        <property name=\"X-EVOLUTION-MANAGER\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"KDE\"/> <!-- disable X-EVOLUTION-MANAGER for KDE -->\n"
"        <property name=\"X-EVOLUTION-MANAGER\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"other\">\n"
"          <value field=\"MANAGER\"/>\n"
"        </property>\n"
"        <property name=\"X-MANAGER\" suppressempty=\"yes\" rule=\"EVOLUTION\"/> <!-- disables the X-MANAGER for EVOLUTION -->\n"
"        <property name=\"X-MANAGER\" suppressempty=\"yes\" rule=\"KDE\"/> <!-- disables the X-MANAGER for KDE -->\n"
"        <property name=\"X-MANAGER\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"MANAGER\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-ManagersName\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"MANAGER\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-EVOLUTION-ASSISTANT\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"KDE\"/>\n"
"        <property name=\"X-EVOLUTION-ASSISTANT\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"other\">\n"
"          <value field=\"ASSISTANT\"/>\n"
"        </property>\n"
"        <property name=\"X-ASSISTANT\" suppressempty=\"yes\" rule=\"EVOLUTION\"/>\n"
"        <property name=\"X-ASSISTANT\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-ASSISTANT\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"ASSISTANT\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-AssistantsName\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"ASSISTANT\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-ABRELATEDNAMES\" suppressempty=\"yes\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"RELATEDNAMES\"/>\n"
"          <position field=\"RELATEDNAMES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"X-EVOLUTION-SPOUSE\" suppressempty=\"yes\" delayedparsing=\"1\" rule =\"KDE\"/>\n"
"        <property name=\"X-EVOLUTION-SPOUSE\" suppressempty=\"yes\" delayedparsing=\"1\" rule =\"other\">\n"
"          <value field=\"SPOUSE\" show=\"yes\"/>\n"
"        </property>\n"
"        <property name=\"X-SPOUSE\" suppressempty=\"yes\" rule=\"EVOLUTION\"/>\n"
"        <property name=\"X-SPOUSE\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-SPOUSE\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"SPOUSE\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-SpousesName\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"SPOUSE\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-EVOLUTION-ANNIVERSARY\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"KDE\"/>\n"
"        <property name=\"X-EVOLUTION-ANNIVERSARY\" suppressempty=\"yes\" delayedparsing=\"1\" rule=\"other\">\n"
"          <value field=\"ANNIVERSARY\"/>\n"
"        </property>\n"
"        <property name=\"X-ANNIVERSARY\" suppressempty=\"yes\" rule=\"EVOLUTION\"/>\n"
"        <property name=\"X-ANNIVERSARY\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-ANNIVERSARY\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"ANNIVERSARY\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-Anniversary\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"ANNIVERSARY\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-ABDATE\" suppressempty=\"yes\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"XDATE\" conversion=\"DATE+EXTFMT\"/>\n"
"          <position field=\"XDATE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"IMPP\" suppressempty=\"yes\" groupfield=\"GROUP_TAG\">\n"
"          <value field=\"IMPP\"/>\n"
"          <position field=\"IMPP\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT-IN-IMPP\">\n"
"            <value field=\"IMPP_SLOT\"/>\n"
"          </parameter>\n"
"          <parameter name=\"X-SERVICE-TYPE\" positional=\"no\" show=\"no\">\n"
"            <value field=\"IMPP_SERVICE\"/>\n"
"          </parameter>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"X-AIM\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-AIM\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"AIM_HANDLE\"/>\n"
"          <position field=\"AIM_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"AIM_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/aim-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"AIM_HANDLE\"/>\n"
"          <position field=\"AIM_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-GADUGADU\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-GADUGADU\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"GADUGADU_HANDLE\"/>\n"
"          <position field=\"GADUGADU_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"GADUGADU_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/gadu-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"GADUGADU_HANDLE\"/>\n"
"          <position field=\"GADUGADU_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"\n"
"        <property name=\"X-GROUPWISE\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-GROUPWISE\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"GROUPWISE_HANDLE\"/>\n"
"          <position field=\"GROUPWISE_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"GROUPWISE_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/groupwise-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"GROUPWISE_HANDLE\"/>\n"
"          <position field=\"GROUPWISE_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-ICQ\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-ICQ\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"ICQ_HANDLE\"/>\n"
"          <position field=\"ICQ_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"ICQ_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/icq-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"ICQ_HANDLE\"/>\n"
"          <position field=\"ICQ_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-JABBER\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-JABBER\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"JABBER_HANDLE\"/>\n"
"          <position field=\"JABBER_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\">\n"
"            <value field=\"JABBER_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/xmpp-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"JABBER_HANDLE\"/>\n"
"          <position field=\"JABBER_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-MSN\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-MSN\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"MSN_HANDLE\"/>\n"
"          <position field=\"MSN_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"MSN_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/msn-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"MSN_HANDLE\"/>\n"
"          <position field=\"MSN_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-YAHOO\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-YAHOO\" suppressempty=\"yes\" rule=\"other\">\n"
"          <value field=\"YAHOO_HANDLE\"/>\n"
"          <position field=\"YAHOO_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"YAHOO_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/yahoo-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"YAHOO_HANDLE\"/>\n"
"          <position field=\"YAHOO_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-SKYPE\" suppressempty=\"yes\" rule=\"KDE\"/>\n"
"        <property name=\"X-SKYPE\" suppressempty=\"yes\" rule=\"other\"> \n"
"          <value field=\"SKYPE_HANDLE\"/>\n"
"          <position field=\"SKYPE_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"SKYPE_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"        <property name=\"X-messaging/skype-All\" suppressempty=\"yes\" show=\"no\" rule=\"KDE\">\n"
"          <value field=\"SKYPE_HANDLE\"/>\n"
"          <position field=\"SKYPE_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"        <!-- No X-messaging/sip-All in KDE?! Then let's use X-SIP for everyone. -->\n"
"        <property name=\"X-SIP\" suppressempty=\"yes\">\n"
"          <value field=\"SIP_HANDLE\"/>\n"
"          <position field=\"SIP_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <parameter name=\"X-EVOLUTION-UI-SLOT\" positional=\"no\" show=\"no\" rule=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"            <value field=\"SIP_SLOT\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <!--\n"
"            KDE way of expressing certain extensions that have no\n"
"            other representations externally. Let's use the same\n"
"            representation as in KDE for everyone else.\n"
"        -->\n"
"        <property name=\"X-messaging/irc-All\" suppressempty=\"yes\">\n"
"          <value field=\"IRC_HANDLE\"/>\n"
"          <position field=\"IRC_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"        <property name=\"X-messaging/meanwhile-All\" suppressempty=\"yes\">\n"
"          <value field=\"MEANWHILE_HANDLE\"/>\n"
"          <position field=\"MEANWHILE_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"        <property name=\"X-messaging/sms-All\" suppressempty=\"yes\">\n"
"          <value field=\"SMS_HANDLE\"/>\n"
"          <position field=\"SMS_HANDLE\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-CRYPTOENCRYPTPREF\" suppressempty=\"yes\">\n"
"          <value field=\"CRYPTOENCRYPTPREF\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-CRYPTOPROTOPREF\" suppressempty=\"yes\">\n"
"          <value field=\"CRYPTOPROTOPREF\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-CRYPTOSIGNPREF\" suppressempty=\"yes\">\n"
"          <value field=\"CRYPTOSIGNPREF\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-OPENPGPFP\" suppressempty=\"yes\">\n"
"          <value field=\"OPENPGPFP\"/>\n"
"        </property>\n"
"        <property name=\"X-KADDRESSBOOK-X-IMAddress\" suppressempty=\"yes\">\n"
"          <value field=\"IM_ADDRESS\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-MOZILLA-HTML\">\n"
"          <value field=\"WANTS_HTML\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"ADR\" values=\"7\" groupfield=\"GROUP_TAG\">\n"
"          <value index=\"0\" field=\"ADR_POBOX\"/>\n"
"          <value index=\"1\" field=\"ADR_ADDTL\"/>\n"
"          <value index=\"2\" field=\"ADR_STREET\"/>\n"
"          <value index=\"3\" field=\"ADR_CITY\"/>\n"
"          <value index=\"4\" field=\"ADR_REG\"/>\n"
"          <value index=\"5\" field=\"ADR_ZIP\"/>\n"
"          <value index=\"6\" field=\"ADR_COUNTRY\"/>\n"
"          <position field=\"ADR_POBOX\" repeat=\"array\" increment=\"1\" minshow=\"1\"/>\n"
"          <parameter name=\"TYPE\" default=\"yes\" positional=\"no\" show=\"yes\">\n"
"            <value field=\"ADR_STREET_FLAGS\" conversion=\"multimix\" combine=\",\">\n"
"              <enum name=\"HOME\"     value=\"B0\"/>\n"
"              <enum name=\"WORK\"     value=\"B1\"/>\n"
"              <enum mode=\"ignore\"   value=\"B2\"/> <!-- OTHER -->\n"
"            </value>\n"
"          </parameter>\n"
"          <parameter name=\"X-ABLabel\" rule=\"HAVE-ABLABEL-PARAMETER\" sharedfield=\"yes\">\n"
"            <value field=\"LABEL\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"BDAY\" rule=\"EXTENDED-DATE-FORMAT\">\n"
"          <value field=\"BDAY\" conversion=\"DATE+EXTFMT\"/>\n"
"        </property>\n"
"        <property name=\"BDAY\" rule=\"other\">\n"
"          <value field=\"BDAY\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"NOTE\" filter=\"no\">\n"
"          <value field=\"NOTE\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"PHOTO\" filter=\"no\">\n"
"          <value field=\"PHOTO\" conversion=\"BLOB_AUTO\"/>\n"
"          <parameter name=\"TYPE\" default=\"no\" show=\"yes\">\n"
"            <value field=\"PHOTO_TYPE\"/>\n"
"          </parameter>\n"
"          <parameter name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"            <value field=\"PHOTO_VALUE\"/>\n"
"          </parameter>\n"
"        </property>\n"
"\n"
"        <property name=\"GEO\" values=\"2\">\n"
"          <value index=\"0\" field=\"GEO_LAT\"/>\n"
"          <value index=\"1\" field=\"GEO_LONG\"/>\n"
"        </property>\n"
"\n"
"        <!-- Label assigned to any of the repeating properties. -->\n"
"        <property name=\"X-ABLabel\" suppressempty=\"yes\" groupfield=\"GROUP_TAG\" rule=\"HAVE-ABLABEL-PROPERTY\">\n"
"          <value field=\"LABEL\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          <position field=\"LABEL\" repeat=\"array\" increment=\"1\" minshow=\"1\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-*\" suppressempty=\"yes\" show=\"false\">\n"
"          <value field=\"XPROPS\"/>\n"
"          <position field=\"XPROPS\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"        </property>\n"
"\n"
"      </profile>\n"
"    </mimeprofile>\n"
"\n"
"\n"
"    <!-- vCard 2.1 datatype, using vCard profile defined above -->\n"
"    <datatype name=\"vCard21\" basetype=\"vcard\">\n"
"      <version>2.1</version>\n"
"      <use mimeprofile=\"vCard\"/>\n"
"     <incomingscript><![CDATA[\n"
"        $VCARD_INCOMING_NAMECHANGE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_TYPE_SCRIPT\n"
"      ]]></incomingscript>\n"
"      <outgoingscript><![CDATA[\n"
"        $VCARD_OUTGOING_ADDREV_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_INLINING_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_OUTGOING_EMAILTYPE_SCRIPT\n"
"      ]]></outgoingscript>\n"
"      <mergescript><![CDATA[\n"
"        $VCARD_MERGESCRIPT\n"
"      ]]></mergescript>\n"
"    </datatype>\n"
"\n"
"    <!-- vCard 3.0 datatype, using vCard profile defined above -->\n"
"    <datatype name=\"vCard30\" basetype=\"vcard\">\n"
"      <version>3.0</version>\n"
"      <use mimeprofile=\"vCard\"/>\n"
"      <incomingscript><![CDATA[\n"
"        $VCARD_INCOMING_NAMECHANGE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_TYPE_SCRIPT\n"
"      ]]></incomingscript>\n"
"      <outgoingscript><![CDATA[\n"
"        $VCARD_OUTGOING_ADDREV_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_INLINING_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_OUTGOING_EMAILTYPE_SCRIPT\n"
"      ]]></outgoingscript>\n"
"      <mergescript><![CDATA[\n"
"        $VCARD_MERGESCRIPT\n"
"      ]]></mergescript>\n"
"    </datatype>\n"
"\n"
"    <!-- vCard 2.1 datatype for use in EDS backend - same as above plus EDS corrections -->\n"
"    <datatype name=\"vCard21EDS\" basetype=\"vcard\">\n"
"      <version>2.1</version>\n"
"      <use mimeprofile=\"vCard\"/>\n"
"     <incomingscript><![CDATA[\n"
"        $VCARD_INCOMING_NAMECHANGE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_TYPE_SCRIPT\n"
"        $VCARD_BEFOREWRITE_SCRIPT_EVOLUTION\n"
"      ]]></incomingscript>\n"
"      <outgoingscript><![CDATA[\n"
"        $VCARD_OUTGOING_ADDREV_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_INLINING_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_OUTGOING_EMAILTYPE_SCRIPT\n"
"      ]]></outgoingscript>\n"
"      <mergescript><![CDATA[\n"
"        $VCARD_MERGESCRIPT\n"
"      ]]></mergescript>\n"
"    </datatype>\n"
"\n"
"    <!-- vCard 3.0 datatype, using vCard profile defined above and special merge script -->\n"
"    <datatype name=\"vCard30EDS\" basetype=\"vcard\">\n"
"      <version>3.0</version>\n"
"      <use mimeprofile=\"vCard\"/>\n"
"      <incomingscript><![CDATA[\n"
"        $VCARD_INCOMING_NAMECHANGE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_INCOMING_PHOTO_TYPE_SCRIPT\n"
"        $VCARD_BEFOREWRITE_SCRIPT_EVOLUTION\n"
"      ]]></incomingscript>\n"
"      <outgoingscript><![CDATA[\n"
"        $VCARD_OUTGOING_ADDREV_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_INLINING_SCRIPT\n"
"        $VCARD_OUTGOING_PHOTO_VALUE_SCRIPT\n"
"        $VCARD_OUTGOING_EMAILTYPE_SCRIPT\n"
"      ]]></outgoingscript>\n"
"      <mergescript><![CDATA[\n"
"        $VCARD_MERGESCRIPT\n"
"      ]]></mergescript>\n"
"    </datatype>\n"
"    <!-- common field list for events and todos (both represented by vCalendar/iCalendar) -->\n"
"    <fieldlist name=\"calendar\">\n"
"      <field name=\"SYNCLVL\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ISEVENT\" type=\"integer\" compare=\"always\"/>\n"
"\n"
"      <field name=\"DMODIFIED\" type=\"timestamp\" compare=\"never\" age=\"yes\"/>\n"
"      <field name=\"DCREATED\" type=\"timestamp\" compare=\"never\"/>\n"
"\n"
"      <field name=\"DGENERATED\" type=\"timestamp\" compare=\"never\"/>\n"
"\n"
"      <field name=\"UID\" type=\"string\" compare=\"never\"/>\n"
"\n"
"      <field name=\"CATEGORIES\" array=\"yes\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"CLASS\" type=\"integer\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"TRANSP\" type=\"integer\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <field name=\"SUMMARY\" type=\"multiline\" compare=\"always\"/>\n"
"      <field name=\"DESCRIPTION\" type=\"multiline\" compare=\"slowsync\" merge=\"lines\"/>\n"
"      <field name=\"LOCATION\" type=\"multiline\" compare=\"slowsync\" merge=\"lines\"/>\n"
"      <field name=\"URL\" type=\"url\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- recurrence rule block, fields must be in that order, including\n"
"           DTSTART as last field !! -->\n"
"      <field name=\"RR_FREQ\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"RR_INTERVAL\" type=\"integer\" compare=\"conflict\"/>\n"
"      <field name=\"RR_FMASK\" type=\"integer\" compare=\"conflict\"/>\n"
"      <field name=\"RR_LMASK\" type=\"integer\" compare=\"conflict\"/>\n"
"      <field name=\"RR_END\" type=\"timestamp\" compare=\"conflict\"/>\n"
"\n"
"      <!-- Note: DTSTART/DTEND are compared in the <comparescript>,\n"
"                 therefore compare is set no \"never\" here -->\n"
"      <field name=\"DTSTART\" type=\"timestamp\" compare=\"never\"/>\n"
"      <field name=\"DTEND\" type=\"timestamp\" compare=\"never\"/>\n"
"      <field name=\"DURATION\" type=\"timestamp\" compare=\"never\"/>\n"
"      <field name=\"COMPLETED\" type=\"timestamp\" compare=\"never\"/>\n"
"      <field name=\"DUE\" type=\"timestamp\" compare=\"never\"/>\n"
"\n"
"      <field name=\"GEO_LAT\" type=\"string\" compare=\"never\"/>\n"
"      <field name=\"GEO_LONG\" type=\"string\" compare=\"never\"/>\n"
"\n"
"      <field name=\"PRIORITY\" type=\"integer\" compare=\"conflict\"/>\n"
"      <field name=\"STATUS\" type=\"integer\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"PERCENT_COMPLETE\" type=\"integer\" compare=\"conflict\"/>\n"
"\n"
"      <field name=\"ALARM_TIME\" type=\"timestamp\" compare=\"conflict\"/>\n"
"      <field name=\"ALARM_SNOOZE\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ALARM_REPEAT\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ALARM_MSG\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ALARM_ACTION\" type=\"string\" compare=\"conflict\"/>\n"
"      <field name=\"ALARM_REL\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ALARM_UID\" type=\"string\" compare=\"never\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- non-standard -->\n"
"      <field name=\"PARENT_UID\" type=\"string\" compare=\"never\"/>\n"
"\n"
"      <!-- for events -->\n"
"      <field name=\"EXDATES\" array=\"yes\" type=\"timestamp\" compare=\"never\"/>\n"
"\n"
"      <!-- EXDATEs for detached recurrences: meant to be used for the\n"
"           RECURRENCE-IDs of all detached recurrences.\n"
"\n"
"           Can be ignored when dealing with only iCalendar 2.0 aware\n"
"           peers, because these EXDATEs are implied for detached\n"
"           recurrences and don't have to be specified explicitly. Can\n"
"           be used to create additional EXDATEs for non-iCalendar 2.0\n"
"           peers. For that, EXDATES_DETACHED must be populated by the\n"
"           backend creating the parent event, because the engine\n"
"           itself doesn't have the necessary\n"
"           information. X-SYNCEVOLUTION-EXDATE-DETACHED can be used\n"
"           for that in serialized calendar events. -->\n"
"      <field name=\"EXDATES_DETACHED\" array=\"yes\" type=\"timestamp\" compare=\"never\"/>\n"
"\n"
"      <field name=\"ORIGSTART\" array=\"no\" type=\"timestamp\" compare=\"never\"/>\n"
"      <field name=\"SEQNO\" array=\"no\" type=\"integer\" compare=\"never\"/>\n"
"\n"
"      <field name=\"ATTENDEES\" array=\"yes\" type=\"string\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_CNS\" array=\"yes\" type=\"string\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_PARTSTATS\" array=\"yes\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_ROLE\" array=\"yes\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_RSVP\" array=\"yes\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_LANG\" array=\"yes\" type=\"string\" compare=\"never\"/>\n"
"      <field name=\"ATTENDEE_CUTYPE\" array=\"yes\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"ORGANIZER\" array=\"no\" type=\"string\" compare=\"never\"/>\n"
"      <field name=\"ORGANIZER_CN\" array=\"no\" type=\"string\" compare=\"never\"/>\n"
"\n"
"    </fieldlist>\n"
"    <!-- vCalendar with VTODO and VEVENT variants -->\n"
"    <mimeprofile name=\"vCalendar\" fieldlist=\"calendar\">\n"
"\n"
"      <vtimezonegenmode>current</vtimezonegenmode>\n"
"      <tzidgenmode>olson</tzidgenmode>\n"
"\n"
"      <profile name=\"VCALENDAR\" nummandatory=\"1\">\n"
"\n"
"        <property name=\"VERSION\" mandatory=\"yes\">\n"
"          <value conversion=\"version\"/>\n"
"        </property>\n"
"\n"
"        <property onlyformode=\"standard\" name=\"PRODID\" mandatory=\"no\">\n"
"          <value conversion=\"prodid\"/>\n"
"        </property>\n"
"\n"
"        <property onlyformode=\"old\" name=\"TZ\" filter=\"false\" suppressempty=\"yes\">\n"
"          <value field=\"DTSTART\" conversion=\"tz\"/>\n"
"        </property>\n"
"\n"
"        <property onlyformode=\"old\" name=\"DAYLIGHT\" mode=\"daylight\" filter=\"false\" suppressempty=\"yes\">\n"
"          <value field=\"DTSTART\" conversion=\"daylight\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"GEO\" values=\"2\" suppressempty=\"yes\" onlyformode=\"old\" valueseparator=\",\">\n"
"          <!-- LON,LAT in vCalendar 1.0 -->\n"
"          <value index=\"0\" field=\"GEO_LAT\"/>\n"
"          <value index=\"1\" field=\"GEO_LONG\"/>\n"
"        </property>\n"
"\n"
"        <subprofile onlyformode=\"standard\" name=\"VTIMEZONE\" mode=\"vtimezones\"/>\n"
"\n"
"        <!-- sub-profile for tasks -->\n"
"        <subprofile name=\"VTODO\" nummandatory=\"1\" showifselectedonly=\"yes\" field=\"ISEVENT\" value=\"0\">\n"
"\n"
"          <property name=\"LAST-MODIFIED\" suppressempty=\"yes\">\n"
"            <value field=\"DMODIFIED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTAMP\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DGENERATED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DCREATED\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"          <property name=\"CREATED\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"UID\" suppressempty=\"yes\">\n"
"            <value field=\"UID\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"SEQUENCE\" suppressempty=\"yes\">\n"
"            <value field=\"SEQNO\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"GEO\" values=\"2\" suppressempty=\"yes\" onlyformode=\"standard\" valueseparator=\";\">\n"
"            <!-- LAT;LON in iCalendar 2.0 -->\n"
"            <value index=\"0\" field=\"GEO_LONG\"/>\n"
"            <value index=\"1\" field=\"GEO_LAT\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"standard\" name=\"CATEGORIES\" values=\"list\" valueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"old\" name=\"CATEGORIES\" values=\"list\" valueseparator=\";\" altvalueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"CLASS\" suppressempty=\"yes\">\n"
"            <value field=\"CLASS\">\n"
"              <enum name=\"PUBLIC\"       value=\"0\"/>\n"
"              <enum name=\"PRIVATE\"      value=\"1\"/>\n"
"              <enum name=\"CONFIDENTIAL\" value=\"2\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property name=\"SUMMARY\" mandatory=\"yes\">\n"
"            <value field=\"SUMMARY\"/>\n"
"          </property>\n"
"\n"
"          <!-- DESCRIPTION is an optional property and libical does not like\n"
"               empty properties, so suppress it here. -->\n"
"          <property name=\"DESCRIPTION\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"DESCRIPTION\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"LOCATION\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"LOCATION\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"URL\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"URL\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTART\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"DTSTART\" conversion=\"autodate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"COMPLETED\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"COMPLETED\" conversion=\"autoenddate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"COMPLETED\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"COMPLETED\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"DUE\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"DUE\" conversion=\"autodate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DUE\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DUE\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"PRIORITY\" suppressempty=\"yes\">\n"
"            <value field=\"PRIORITY\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"STATUS\" onlyformode=\"standard\" suppressempty=\"yes\">\n"
"            <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"              <enum name=\"COMPLETED\"      value=\"0\"/>\n"
"              <enum name=\"NEEDS-ACTION\"   value=\"1\"/>\n"
"              <enum name=\"IN-PROCESS\"     value=\"2\"/>\n"
"              <enum name=\"CANCELLED\"      value=\"3\"/>\n"
"              <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"              <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"              <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              <enum name=\"DECLINED\"       value=\"7\"/>\n"
"              <enum name=\"SENT\"           value=\"8\"/>\n"
"              <enum name=\"CONFIRMED\"      value=\"9\"/>\n"
"              <enum name=\"DRAFT\"          value=\"10\"/>\n"
"              <enum name=\"FINAL\"          value=\"11\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property name=\"STATUS\" onlyformode=\"old\" suppressempty=\"yes\">\n"
"            <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"              <enum name=\"COMPLETED\"      value=\"0\"/>\n"
"              <enum name=\"NEEDS ACTION\"   value=\"1\"/>\n"
"              <enum mode=\"defaultvalue\"   value=\"1\"/> <!-- catch unknown, but also non-conformant NEEDS_ACTION -->\n"
"              <enum name=\"IN PROCESS\"     value=\"2\"/>\n"
"              <enum name=\"CANCELLED\"      value=\"3\"/>\n"
"              <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"              <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"              <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              <enum name=\"DECLINED\"       value=\"7\"/>\n"
"              <enum name=\"SENT\"           value=\"8\"/>\n"
"              <enum name=\"CONFIRMED\"      value=\"9\"/>\n"
"              <enum name=\"DRAFT\"          value=\"10\"/>\n"
"              <enum name=\"FINAL\"          value=\"11\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property name=\"PERCENT-COMPLETE\" onlyformode=\"standard\" suppressempty=\"yes\">\n"
"            <value field=\"PERCENT_COMPLETE\"/>\n"
"          </property>          \n"
"\n"
"          <!-- AALARM and DALARM both use the same fields -->\n"
"          <property name=\"AALARM\" onlyformode=\"old\" values=\"4\" suppressempty=\"yes\">\n"
"            <value index=\"0\" field=\"ALARM_TIME\" conversion=\"emptyonly\"/>\n"
"            <value index=\"1\" field=\"ALARM_SNOOZE\" conversion=\"emptyonly\"/>\n"
"            <value index=\"2\" field=\"ALARM_REPEAT\" conversion=\"emptyonly\"/>\n"
"            <value index=\"3\" field=\"ALARM_MSG\" conversion=\"emptyonly\"/>\n"
"          </property>\n"
"          <property name=\"DALARM\" onlyformode=\"old\" values=\"4\" suppressempty=\"yes\">\n"
"            <value index=\"0\" field=\"ALARM_TIME\" conversion=\"emptyonly\"/>\n"
"            <value index=\"1\" field=\"ALARM_SNOOZE\" conversion=\"emptyonly\"/>\n"
"            <value index=\"2\" field=\"ALARM_REPEAT\" conversion=\"emptyonly\"/>\n"
"            <value index=\"3\" field=\"ALARM_MSG\" conversion=\"emptyonly\"/>\n"
"          </property>\n"
"\n"
"          <subprofile onlyformode=\"standard\" name=\"VALARM\" nummandatory=\"1\" field=\"ALARM_TIME\">\n"
"            <property name=\"TRIGGER\" suppressempty=\"no\" mandatory=\"yes\">\n"
"              <value field=\"ALARM_TIME\"/>\n"
"              <parameter name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"                <value field=\"ALARM_TIME\" conversion=\"FULLVALUETYPE\"/>\n"
"              </parameter>\n"
"              <parameter name=\"RELATED\" default=\"no\" show=\"yes\">\n"
"                <value field=\"ALARM_REL\">\n"
"                  <enum mode=\"ignore\" value=\"0\"/>\n"
"                  <enum name=\"START\" value=\"1\"/>\n"
"                  <enum name=\"END\"   value=\"2\"/>\n"
"                </value>\n"
"              </parameter>\n"
"            </property>\n"
"            <property name=\"ACTION\" suppressempty=\"yes\" mandatory=\"yes\">\n"
"              <value field=\"ALARM_ACTION\"/>\n"
"            </property>\n"
"            <property name=\"DESCRIPTION\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_MSG\"/>\n"
"            </property>\n"
"            <property name=\"REPEAT\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_REPEAT\"/>\n"
"            </property>\n"
"            <property name=\"X-EVOLUTION-ALARM-UID\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_UID\"/>\n"
"            </property>\n"
"          </subprofile>\n"
"\n"
"          <property onlyformode=\"old\" name=\"RELATED-TO\" suppressempty=\"yes\">\n"
"            <value field=\"PARENT_UID\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"standard\" name=\"RELATED-TO\" suppressempty=\"yes\">\n"
"            <value field=\"PARENT_UID\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"RELTYPE\" default=\"no\" positional=\"yes\" show=\"yes\">\n"
"              <value>\n"
"                <enum name=\"PARENT\"/>\n"
"                <enum mode=\"defaultvalue\" name=\"other\"/>\n"
"              </value>\n"
"              <position hasnot=\"other\" shows=\"PARENT\" field=\"PARENT_UID\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"        </subprofile>\n"
"\n"
"        <!-- sub-profile for event -->\n"
"        <subprofile name=\"VEVENT\" nummandatory=\"1\" showifselectedonly=\"yes\" field=\"ISEVENT\" value=\"1\">\n"
"\n"
"            <property rule='needsTZinVEVENT' name=\"TZ\" filter=\"false\" suppressempty=\"yes\">\n"
"                <value field=\"DTSTART\" conversion=\"tz\"/>\n"
"            </property>\n"
"\n"
"            <property name=\"STATUS\"  suppressempty=\"yes\" onlyformode=\"old\">\n"
"                <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"                    <enum name=\"COMPLETED\"      value=\"0\"/>\n"
"                    <enum mode=\"defaultvalue\"   value=\"1\"/> <!-- catch unknown, but also non-conformant NEEDS_ACTION -->\n"
"                    <enum name=\"NEEDS ACTION\"   value=\"1\"/>\n"
"                    <enum name=\"CANCELLED\"      value=\"3\"/>\n"
"                    <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"                    <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"                    <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"                    <enum name=\"DECLINED\"       value=\"7\"/>\n"
"                    <enum name=\"SENT\"           value=\"8\"/>\n"
"                    <enum name=\"CONFIRMED\"      value=\"9\"/>\n"
"                    <enum name=\"FINAL\"          value=\"11\"/>\n"
"                </value>\n"
"            </property>\n"
"\n"
"            <property name=\"STATUS\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"                <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"                    <enum name=\"CANCELLED\" value=\"3\"/>\n"
"                    <enum name=\"TENTATIVE\" value=\"5\"/>\n"
"                    <enum name=\"CONFIRMED\" value=\"9\"/>\n"
"                </value>\n"
"            </property>\n"
"\n"
"          <property name=\"LAST-MODIFIED\" suppressempty=\"yes\">\n"
"            <value field=\"DMODIFIED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTAMP\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DGENERATED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DCREATED\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"          <property name=\"CREATED\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"\n"
"\n"
"          <property name=\"UID\" suppressempty=\"yes\">\n"
"            <value field=\"UID\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"SEQUENCE\" suppressempty=\"yes\">\n"
"            <value field=\"SEQNO\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"GEO\" values=\"2\" suppressempty=\"yes\" onlyformode=\"standard\" valueseparator=\";\">\n"
"            <!-- LAT;LON in iCalendar 2.0 -->\n"
"            <value index=\"0\" field=\"GEO_LONG\"/>\n"
"            <value index=\"1\" field=\"GEO_LAT\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"standard\" name=\"CATEGORIES\" values=\"list\" valueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"old\" name=\"CATEGORIES\" values=\"list\" valueseparator=\";\" altvalueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"CLASS\" suppressempty=\"yes\">\n"
"            <value field=\"CLASS\">\n"
"              <enum name=\"PUBLIC\"       value=\"0\"/>\n"
"              <enum name=\"PRIVATE\"      value=\"1\"/>\n"
"              <enum name=\"CONFIDENTIAL\" value=\"2\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"\n"
"          <property name=\"TRANSP\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"TRANSP\">\n"
"              <enum name=\"OPAQUE\"       value=\"0\"/>\n"
"              <enum name=\"TRANSPARENT\"  value=\"1\"/>\n"
"              <enum name=\"TENTATIVE\"     value=\"2\"/> <!-- according to Oracle de facto usage in vCalendar 1.0 -->\n"
"              <enum name=\"OUT_OF_OFFICE\" value=\"3\"/> <!-- according to Oracle de facto usage in vCalendar 1.0 -->\n"
"              <enum mode=\"defaultvalue\" value=\"0\"/>\n"
"            </value>\n"
"          </property>\n"
"          <property name=\"TRANSP\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"TRANSP\"/> <!-- directly numeric in vCalendar 1.0 -->\n"
"          </property>\n"
"\n"
"\n"
"          <property name=\"PRIORITY\" suppressempty=\"yes\">\n"
"            <value field=\"PRIORITY\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"SUMMARY\" mandatory=\"yes\">\n"
"            <value field=\"SUMMARY\"/>\n"
"          </property>\n"
"\n"
"          <!-- DESCRIPTION is an optional property and libical does not like\n"
"               empty properties, so suppress it here. -->\n"
"          <property name=\"DESCRIPTION\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"DESCRIPTION\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"LOCATION\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"LOCATION\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTART\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"DTSTART\" conversion=\"autodate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <!-- recurrence rule (with delayed parsing, as it is dependent on DTSTART) -->\n"
"          <property name=\"RRULE\" suppressempty=\"yes\" delayedparsing=\"2\">\n"
"            <!-- Note: RR_FREQ is the beginning of a block of fields\n"
"                 suitable for the \"rrule\" conversion mode -->\n"
"            <value field=\"RR_FREQ\" conversion=\"rrule\"/>\n"
"          </property>\n"
"\n"
"          <!-- Symbian uses this, so it might make the client work with symbian-prepared servers better -->\n"
"          <property name=\"X-RECURRENCE-ID\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"ORIGSTART\" conversion=\"autodate\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"RECURRENCE-ID\" suppressempty=\"yes\" onlyformode=\"standard\" delayedparsing=\"1\">\n"
"            <value field=\"ORIGSTART\" conversion=\"autodate\"/>\n"
"            <parameter name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ORIGSTART\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ORIGSTART\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <!-- ScheduleWorld has a problem (bugzilla.moblin.org #2226)\n"
"               with the EXDATE:value1,value2 format (correct in iCalendar 2.0):\n"
"               as a workaround, accept all valid formats plus ; but\n"
"               generate separate properties with one value each. -->\n"
"          <!-- The simplified version of EXDATE is needed by the Maemo Calendar backend\n"
"               because the calendar storage doesn't parse EXDATE;TZID=...: -->\n"
"          <property name=\"EXDATE\" values=\"expandedlist\" suppressempty=\"yes\" onlyformode=\"standard\" delayedparsing=\"1\" valueseparator=\",\" altvalueseparator=\";\" rule=\"SIMPLE-EXDATE\">\n"
"            <value field=\"EXDATES\"/>\n"
"            <position field=\"EXDATES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          </property>\n"
"          <property name=\"EXDATE\" values=\"expandedlist\" suppressempty=\"yes\" onlyformode=\"standard\" delayedparsing=\"1\" valueseparator=\",\" altvalueseparator=\";\" rule=\"other\">\n"
"            <value field=\"EXDATES\"/>\n"
"            <position field=\"EXDATES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"            <parameter name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"EXDATES\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"EXDATES\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"EXDATE\" values=\"list\" suppressempty=\"yes\" onlyformode=\"old\" delayedparsing=\"1\" valueseparator=\";\" altvalueseparator=\",\">\n"
"            <value field=\"EXDATES\" conversion=\"autodate\"/>\n"
"            <position field=\"EXDATES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <!-- parse X-SYNCEVOLUTION-EXDATE-DETACHED, but never encode it like this except internally -->\n"
"          <property name=\"X-SYNCEVOLUTION-EXDATE-DETACHED\" delayedparsing=\"1\" mandatory=\"no\"\n"
"                    show=\"no\" rule=\"HAVE-SYNCEVOLUTION-EXDATE-DETACHED\">\n"
"            <value field=\"EXDATES_DETACHED\"/>\n"
"            <parameter name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"EXDATES_DETACHED\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <position field=\"EXDATES_DETACHED\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          </property>\n"
"          <!-- encode as normal EXDATE when backend asks for it -->\n"
"          <property name=\"EXDATE\" show=\"no\" rule=\"HAVE-EXDATE-DETACHED\" mandatory=\"no\">\n"
"            <value field=\"EXDATES_DETACHED\"/>\n"
"            <parameter name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"EXDATES_DETACHED\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <position field=\"EXDATES_DETACHED\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          </property>\n"
"          <!-- encode as EXDATE without TZID when backend asks for it -->\n"
"          <property name=\"EXDATE\" show=\"no\" rule=\"HAVE-EXDATE-DETACHED-NO-TZID\" mandatory=\"no\">\n"
"            <value field=\"EXDATES_DETACHED\"/>\n"
"            <position field=\"EXDATES_DETACHED\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTEND\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"DTEND\" conversion=\"autoenddate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTEND\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTEND\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"DURATION\" suppressempty=\"yes\" delayedparsing=\"1\" onlyformode=\"standard\">\n"
"            <value field=\"DURATION\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"no\">\n"
"              <value field=\"DURATION\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"ATTENDEE\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"ATTENDEES\"/>\n"
"            <parameter name=\"ROLE\" default=\"no\" positional=\"yes\" show=\"yes\">\n"
"              <value>\n"
"                <enum name=\"ORGANIZER\"/>\n"
"              </value>\n"
"              <position has=\"ORGANIZER\" field=\"ORGANIZER\" overwriteempty=\"yes\"/>\n"
"              <position hasnot=\"ORGANIZER\" field=\"ATTENDEES\" repeat=\"array\" increment=\"1\" overwriteempty=\"yes\"/>\n"
"            </parameter>\n"
"            <parameter name=\"STATUS\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_PARTSTATS\">\n"
"                <enum name=\"NEEDS ACTION\"   value=\"1\"/>\n"
"                <enum mode=\"defaultvalue\"   value=\"1\"/> <!-- catch unknown, but also non-conformant NEEDS_ACTION -->\n"
"                <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"                <enum name=\"DECLINED\"       value=\"7\"/>\n"
"                <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"                <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              </value>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"ATTENDEE\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"ATTENDEES\" conversion=\"mailto\"/>\n"
"            <position field=\"ATTENDEES\" repeat=\"array\" increment=\"1\" minshow=\"0\"/>\n"
"            <parameter name=\"CN\" default=\"no\" show=\"yes\" shownonempty=\"yes\">\n"
"              <value field=\"ATTENDEE_CNS\"/>\n"
"            </parameter>\n"
"            <parameter name=\"PARTSTAT\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_PARTSTATS\">\n"
"                <enum name=\"NEEDS-ACTION\"   value=\"1\"/>\n"
"                <enum mode=\"defaultvalue\"   value=\"1\"/> <!-- catch unknown, but also non-conformant NEEDS_ACTION -->\n"
"                <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"                <enum name=\"DECLINED\"       value=\"7\"/>\n"
"                <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"                <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              </value>\n"
"            </parameter>\n"
"            <parameter name=\"ROLE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_ROLE\">\n"
"                <enum name=\"CHAIR\"            value=\"1\"/>\n"
"                <enum name=\"REQ-PARTICIPANT\"  value=\"2\"/>\n"
"                <enum name=\"OPT-PARTICIPANT\"  value=\"3\"/>\n"
"                <enum name=\"NON-PARTICIPANT\"  value=\"4\"/>\n"
"              </value>\n"
"            </parameter>\n"
"            <parameter name=\"RSVP\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_RSVP\">\n"
"                <enum name=\"TRUE\"             value=\"1\"/>\n"
"                <enum name=\"FALSE\"            value=\"0\"/>\n"
"              </value>\n"
"            </parameter>\n"
"            <parameter name=\"LANGUAGE\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_LANG\"/>\n"
"            </parameter>\n"
"            <parameter name=\"CUTYPE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ATTENDEE_CUTYPE\">\n"
"                <enum name=\"INDIVIDUAL\"  value=\"1\"/>\n"
"                <enum name=\"GROUP\"       value=\"2\"/>\n"
"                <enum name=\"RESOURCE\"    value=\"3\"/>\n"
"                <enum name=\"ROOM\"        value=\"4\"/>\n"
"                <enum name=\"UNKNOWN\"     value=\"5\"/>\n"
"              </value>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"ORGANIZER\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"ORGANIZER\" conversion=\"mailto\"/>\n"
"            <parameter name=\"CN\" default=\"no\" show=\"yes\">\n"
"              <value field=\"ORGANIZER_CN\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <!-- AALARM and DALARM both use the same fields -->\n"
"          <property name=\"AALARM\" onlyformode=\"old\" values=\"4\" suppressempty=\"yes\">\n"
"            <value index=\"0\" field=\"ALARM_TIME\" conversion=\"emptyonly\"/>\n"
"            <value index=\"1\" field=\"ALARM_SNOOZE\" conversion=\"emptyonly\"/>\n"
"            <value index=\"2\" field=\"ALARM_REPEAT\" conversion=\"emptyonly\"/>\n"
"            <value index=\"3\" field=\"ALARM_MSG\" conversion=\"emptyonly\"/>\n"
"          </property>\n"
"          <property name=\"DALARM\" onlyformode=\"old\" values=\"4\" suppressempty=\"yes\">\n"
"            <value index=\"0\" field=\"ALARM_TIME\" conversion=\"emptyonly\"/>\n"
"            <value index=\"1\" field=\"ALARM_SNOOZE\" conversion=\"emptyonly\"/>\n"
"            <value index=\"2\" field=\"ALARM_REPEAT\" conversion=\"emptyonly\"/>\n"
"            <value index=\"3\" field=\"ALARM_MSG\" conversion=\"emptyonly\"/>\n"
"          </property>\n"
"\n"
"          <subprofile onlyformode=\"standard\" name=\"VALARM\" nummandatory=\"1\" field=\"ALARM_TIME\">\n"
"            <property name=\"TRIGGER\" suppressempty=\"no\" mandatory=\"yes\">\n"
"              <value field=\"ALARM_TIME\"/>\n"
"              <parameter name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"                <value field=\"ALARM_TIME\" conversion=\"FULLVALUETYPE\"/>\n"
"              </parameter>\n"
"              <parameter name=\"RELATED\" default=\"no\" show=\"yes\">\n"
"                <value field=\"ALARM_REL\">\n"
"                  <enum mode=\"ignore\" value=\"0\"/>\n"
"                  <enum name=\"START\" value=\"1\"/>\n"
"                  <enum name=\"END\"   value=\"2\"/>\n"
"                </value>\n"
"              </parameter>\n"
"            </property>\n"
"            <property name=\"ACTION\" suppressempty=\"yes\" mandatory=\"yes\">\n"
"              <value field=\"ALARM_ACTION\"/>\n"
"            </property>\n"
"            <property name=\"DESCRIPTION\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_MSG\"/>\n"
"            </property>\n"
"            <property name=\"REPEAT\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_REPEAT\"/>\n"
"            </property>\n"
"            <property name=\"X-EVOLUTION-ALARM-UID\" suppressempty=\"yes\">\n"
"              <value field=\"ALARM_UID\"/>\n"
"            </property>\n"
"          </subprofile>\n"
"\n"
"        </subprofile>\n"
"\n"
"        <!-- sub-profile for journal: recurrences are allowed by the standard, but\n"
"             intentionally not supported here -->\n"
"        <subprofile name=\"VJOURNAL\" nummandatory=\"1\" showifselectedonly=\"yes\" field=\"ISEVENT\" value=\"2\">\n"
"\n"
"          <property name=\"LAST-MODIFIED\" suppressempty=\"yes\">\n"
"            <value field=\"DMODIFIED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTAMP\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DGENERATED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DCREATED\" suppressempty=\"yes\" onlyformode=\"old\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"          <property name=\"CREATED\" suppressempty=\"yes\" onlyformode=\"standard\">\n"
"            <value field=\"DCREATED\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"UID\" suppressempty=\"yes\">\n"
"            <value field=\"UID\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"SEQUENCE\" suppressempty=\"yes\">\n"
"            <value field=\"SEQNO\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"standard\" name=\"CATEGORIES\" values=\"list\" valueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"old\" name=\"CATEGORIES\" values=\"list\" valueseparator=\";\" altvalueseparator=\",\" suppressempty=\"yes\">\n"
"            <value field=\"CATEGORIES\" />\n"
"            <position field=\"CATEGORIES\" repeat=\"array\" minshow=\"0\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"CLASS\" suppressempty=\"yes\">\n"
"            <value field=\"CLASS\">\n"
"              <enum name=\"PUBLIC\"       value=\"0\"/>\n"
"              <enum name=\"PRIVATE\"      value=\"1\"/>\n"
"              <enum name=\"CONFIDENTIAL\" value=\"2\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property name=\"SUMMARY\" mandatory=\"yes\">\n"
"            <value field=\"SUMMARY\"/>\n"
"          </property>\n"
"\n"
"          <!-- DESCRIPTION is an optional property and libical does not like\n"
"               empty properties, so suppress it here. -->\n"
"          <property name=\"DESCRIPTION\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"DESCRIPTION\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"URL\" suppressempty=\"yes\" mandatory=\"no\">\n"
"            <value field=\"URL\"/>\n"
"          </property>\n"
"\n"
"          <property name=\"DTSTART\" suppressempty=\"yes\" delayedparsing=\"1\">\n"
"            <value field=\"DTSTART\" conversion=\"autodate\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"TZID\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"TZID\"/>\n"
"            </parameter>\n"
"            <parameter onlyformode=\"standard\" name=\"VALUE\" default=\"no\" show=\"yes\">\n"
"              <value field=\"DTSTART\" conversion=\"VALUETYPE\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"          <property name=\"STATUS\" onlyformode=\"standard\" suppressempty=\"yes\">\n"
"            <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"              <enum name=\"COMPLETED\"      value=\"0\"/>\n"
"              <enum name=\"NEEDS-ACTION\"   value=\"1\"/>\n"
"              <enum name=\"IN-PROCESS\"     value=\"2\"/>\n"
"              <enum name=\"CANCELLED\"      value=\"3\"/>\n"
"              <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"              <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"              <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              <enum name=\"DECLINED\"       value=\"7\"/>\n"
"              <enum name=\"SENT\"           value=\"8\"/>\n"
"              <enum name=\"CONFIRMED\"      value=\"9\"/>\n"
"              <enum name=\"DRAFT\"          value=\"10\"/>\n"
"              <enum name=\"FINAL\"          value=\"11\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property name=\"STATUS\" onlyformode=\"old\" suppressempty=\"yes\">\n"
"            <value field=\"STATUS\" conversion=\"emptyonly\">\n"
"              <enum name=\"COMPLETED\"      value=\"0\"/>\n"
"              <enum name=\"NEEDS ACTION\"   value=\"1\"/>\n"
"              <enum mode=\"defaultvalue\"   value=\"1\"/> <!-- catch unknown, but also non-conformant NEEDS_ACTION -->\n"
"              <enum name=\"IN PROCESS\"     value=\"2\"/>\n"
"              <enum name=\"CANCELLED\"      value=\"3\"/>\n"
"              <enum name=\"ACCEPTED\"       value=\"4\"/>\n"
"              <enum name=\"TENTATIVE\"      value=\"5\"/>\n"
"              <enum name=\"DELEGATED\"      value=\"6\"/>\n"
"              <enum name=\"DECLINED\"       value=\"7\"/>\n"
"              <enum name=\"SENT\"           value=\"8\"/>\n"
"              <enum name=\"CONFIRMED\"      value=\"9\"/>\n"
"              <enum name=\"DRAFT\"          value=\"10\"/>\n"
"              <enum name=\"FINAL\"          value=\"11\"/>\n"
"            </value>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"old\" name=\"RELATED-TO\" suppressempty=\"yes\">\n"
"            <value field=\"PARENT_UID\"/>\n"
"          </property>\n"
"\n"
"          <property onlyformode=\"standard\" name=\"RELATED-TO\" suppressempty=\"yes\">\n"
"            <value field=\"PARENT_UID\"/>\n"
"            <parameter onlyformode=\"standard\" name=\"RELTYPE\" default=\"no\" positional=\"yes\" show=\"yes\">\n"
"              <value>\n"
"                <enum name=\"PARENT\"/>\n"
"                <enum mode=\"defaultvalue\" name=\"other\"/>\n"
"              </value>\n"
"              <position hasnot=\"other\" shows=\"PARENT\" field=\"PARENT_UID\"/>\n"
"            </parameter>\n"
"          </property>\n"
"\n"
"        </subprofile>\n"
"\n"
"      </profile>\n"
"    </mimeprofile>\n"
"\n"
"    <textprofile name=\"JournalText\" fieldlist=\"calendar\">\n"
"      <linemap field=\"SUMMARY\">\n"
"        <numlines>1</numlines>\n"
"        <inheader>false</inheader>\n"
"        <allowempty>true</allowempty>\n"
"        <filterkeyword>SUMMARY</filterkeyword>\n"
"      </linemap>\n"
"      <linemap field=\"DESCRIPTION\">\n"
"        <numlines>0</numlines>\n"
"        <inheader>false</inheader>\n"
"        <allowempty>true</allowempty>\n"
"      </linemap>\n"
"    </textprofile>\n"
"    <!-- vCalendar 1.0 datatype, using vCalendar profile defined above -->\n"
"    <datatype name=\"vCalendar10\" basetype=\"vcalendar\">\n"
"      <version>1.0</version>\n"
"      <use mimeprofile=\"vCalendar\"/>\n"
"\n"
"      <incomingscript><![CDATA[\n"
"        $VCALENDAR_INCOMING_SCRIPT\n"
"      ]]></incomingscript>\n"
"\n"
"      <outgoingscript><![CDATA[\n"
"        $VCALENDAR_OUTGOING_SCRIPT\n"
"      ]]></outgoingscript>\n"
"\n"
"      <comparescript><![CDATA[\n"
"        $VCALENDAR_COMPARE_SCRIPT\n"
"      ]]></comparescript>\n"
"    </datatype>\n"
"\n"
"\n"
"    <!-- iCalendar 2.0 datatype, using vCalendar profile defined above -->\n"
"    <datatype name=\"iCalendar20\" basetype=\"vcalendar\">\n"
"      <version>2.0</version>\n"
"      <use mimeprofile=\"vCalendar\"/>\n"
"\n"
"      <incomingscript><![CDATA[\n"
"        $VCALENDAR_INCOMING_SCRIPT\n"
"      ]]></incomingscript>\n"
"\n"
"      <outgoingscript><![CDATA[\n"
"        $VCALENDAR_OUTGOING_SCRIPT\n"
"      ]]></outgoingscript>\n"
"\n"
"      <comparescript><![CDATA[\n"
"        $VCALENDAR_COMPARE_SCRIPT\n"
"      ]]></comparescript>\n"
"    </datatype>\n"
"\n"
"    <datatype name=\"journaltext10\" basetype=\"text\">\n"
"      <use profile=\"JournalText\"/>\n"
"      <typestring>text/plain</typestring>\n"
"      <versionstring>1.0</versionstring>\n"
"\n"
"      <incomingscript><![CDATA[\n"
"        $MEMO_INCOMING_SCRIPT\n"
"      ]]></incomingscript>\n"
"\n"
"      <outgoingscript><![CDATA[\n"
"        $MEMO_OUTGOING_SCRIPT\n"
"      ]]></outgoingscript>\n"
"    </datatype>\n"
"\n"
"    <datatype name=\"journaltext11\" basetype=\"text\">\n"
"      <use profile=\"JournalText\"/>\n"
"      <typestring>text/plain</typestring>\n"
"      <versionstring>1.1</versionstring>\n"
"\n"
"      <incomingscript><![CDATA[\n"
"        $MEMO_INCOMING_SCRIPT\n"
"      ]]></incomingscript>\n"
"\n"
"      <outgoingscript><![CDATA[\n"
"        $MEMO_OUTGOING_SCRIPT\n"
"      ]]></outgoingscript>\n"
"    </datatype>\n"
"    <!-- list of internal fields representing plain text note data -->\n"
"    <fieldlist name=\"Note\">\n"
"      <field name=\"SYNCLVL\" type=\"integer\" compare=\"never\"/>\n"
"      <field name=\"SUBJECT\" type=\"multiline\" compare=\"always\"/>\n"
"      <field name=\"TEXT\" type=\"multiline\" compare=\"conflict\" merge=\"lines\"/>\n"
"    </fieldlist>\n"
"\n"
"    <textprofile name=\"Note\" fieldlist=\"Note\">\n"
"      <linemap field=\"SUBJECT\">\n"
"        <numlines>1</numlines>\n"
"        <inheader>false</inheader>\n"
"        <allowempty>true</allowempty>\n"
"        <filterkeyword>SUBJECT</filterkeyword>\n"
"      </linemap>\n"
"      <linemap field=\"TEXT\">\n"
"        <numlines>0</numlines>\n"
"        <inheader>false</inheader>\n"
"        <allowempty>true</allowempty>\n"
"      </linemap>\n"
"    </textprofile>\n"
"\n"
"    <datatype name=\"note10\" basetype=\"text\">\n"
"      <use profile=\"Note\"/>\n"
"      <typestring>text/plain</typestring>\n"
"      <versionstring>1.0</versionstring>\n"
"    </datatype>\n"
"\n"
"    <datatype name=\"note11\" basetype=\"text\">\n"
"      <use profile=\"Note\"/>\n"
"      <typestring>text/plain</typestring>\n"
"      <versionstring>1.1</versionstring>\n"
"    </datatype>\n"
"\n"
"    <!-- list of internal fields representing vBookmark data -->\n"
"    <fieldlist name=\"bookmarks\">\n"
"      <field name=\"REV\" type=\"timestamp\" compare=\"never\" age=\"yes\"/>\n"
"      <field name=\"SYNCLVL\" type=\"integer\" compare=\"never\"/>\n"
"\n"
"      <!-- Name -->\n"
"      <field name=\"TITLE\" type=\"string\" compare=\"always\"/>\n"
"\n"
"      <!-- categories and classification -->\n"
"      <field name=\"CATEGORIES\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"      <field name=\"CLASS\" type=\"string\" compare=\"conflict\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- web addresses -->\n"
"      <field name=\"URL\" type=\"url\" compare=\"slowsync\" merge=\"fillempty\"/>\n"
"\n"
"      <!-- Note -->\n"
"      <field name=\"NOTE\" type=\"multiline\" compare=\"conflict\" merge=\"lines\"/>\n"
"\n"
"    </fieldlist>\n"
"\n"
"    <!-- vBookmark profile -->\n"
"    <mimeprofile name=\"vBookmark\" fieldlist=\"bookmarks\">\n"
"\n"
"      <profile name=\"VBKM\" nummandatory=\"0\">\n"
"        <property name=\"VERSION\">\n"
"          <value conversion=\"version\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"X-LAST-MODIFIED\">\n"
"          <value field=\"REV\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"TITLE\">\n"
"          <value field=\"TITLE\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"URL\">\n"
"          <value field=\"URL\"/>\n"
"        </property>\n"
"\n"
"        <!-- non-standard properties -->\n"
"\n"
"        <!-- inherit CATEGORIES from vCard 3.0, i.e. comma separated -->\n"
"        <property name=\"CATEGORIES\" values=\"list\" valueseparator=\",\" altvalueseparator=\";\">\n"
"          <value field=\"CATEGORIES\" combine=\",\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"CLASS\" suppressempty=\"yes\">\n"
"          <value field=\"CLASS\"/>\n"
"        </property>\n"
"\n"
"        <property name=\"NOTE\" filter=\"no\">\n"
"          <value field=\"NOTE\"/>\n"
"        </property>\n"
"\n"
"      </profile>\n"
"    </mimeprofile>\n"
"\n"
"    <!-- vBookmark datatype, using vBookmark profile defined above -->\n"
"    <datatype name=\"vBookmark10\" basetype=\"mimedir\">\n"
"      <typestring>text/x-vbookmark</typestring>\n"
"      <versionstring>1.0</versionstring>\n"
"      <use profile=\"vBookmark\"/>\n"
"    </datatype>\n"
"\n"
"    <!-- list of internal fields representing plain text note data -->\n"
"    <fieldlist name=\"Raw\">\n"
"      <field name=\"ITEMDATA\" type=\"string\" compare=\"always\"/>\n"
"    </fieldlist>\n"
"\n"
"    <datatype name=\"raw-vcard\" basetype=\"raw\">\n"
"      <use fieldlist=\"Raw\"/>\n"
"      <typestring>text/vcard</typestring>\n"
"      <versionstring>3.0</versionstring>\n"
"    </datatype>\n"
"\n"
"    <datatype name=\"raw-calendar\" basetype=\"raw\">\n"
"      <use fieldlist=\"Raw\"/>\n"
"      <typestring>text/calendar</typestring>\n"
"      <versionstring>2.0</versionstring>\n"
"    </datatype>\n"
"\n"
"    <fieldlists/>\n"
"    <profiles/>\n"
"    <datatypedefs/>\n"
"  </datatypes>\n"
"\n"
"  <clientorserver/>\n"
"</sysync_config>\n"
;
const char *SyncEvolutionXMLClientRules =
"    <subrule name=\"HAVE-ABLABEL-PROPERTY\">\n"
"      <!-- property X-ABLabel is not generated by default,\n"
"           must be enabled for peers which support it -->\n"
"    </subrule>\n"
"\n"
"    <subrule name=\"HAVE-ABLABEL-PARAMETER\">\n"
"      <!-- parameter X-ABLabel is not generated by default,\n"
"           must be enabled for peers which support it -->\n"
"    </subrule>\n"
"<!-- parameter X-EVOLUTION-UI-SLOT is not generated by default,\n"
"     must be enabled for peers which support it -->\n"
"\n"
"    <subrule name=\"HAVE-EVOLUTION-UI-SLOT\">\n"
"    </subrule>\n"
"\n"
"    <subrule name=\"HAVE-EVOLUTION-UI-SLOT-IN-IMPP\">\n"
"    </subrule>\n"
"    <subrule name=\"HAVE-EXDATE-DETACHED\"/>\n"
"    <subrule name=\"HAVE-EXDATE-DETACHED-NO-TZID\"/>\n"
"    <subrule name=\"HAVE-SYNCEVOLUTION-EXDATE-DETACHED\"/>\n"
"<subrule name=\"needsTZInVEVENT\"></subrule>\n"
"<subrule name=\"SIMPLE-EXDATE\"></subrule>\n"
"    <remoterule name=\"SyncEvolution\">\n"
"      <manufacturer>Patrick Ohly</manufacturer>\n"
"      <model>SyncEvolution</model>\n"
"\n"
"      <!-- enable reordering when talking to ourselves, enables asynchronous and batched execution -->\n"
"      <strictexecordering>no</strictexecordering>\n"
"\n"
"      <!-- No need to send empty properties, we don't need them to indicate when\n"
"       something isn't present because we use CtCap for that. -->\n"
"      <noemptyproperties>yes</noemptyproperties>\n"
"\n"
"      <include rule=\"HAVE-SYNCEVOLUTION-EXDATE-DETACHED\"/>\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT\"/>\n"
"      <include rule=\"HAVE-ABLABEL-PARAMETER\"/>\n"
"\n"
"      <!-- Merging between SyncEvolution instances is expected to work\n"
"           well, so allow the engine to update items on both\n"
"           sides also in the \"non-first\" slow sync case.\n"
"\n"
"           This is turned off by default for other clients\n"
"           because small changes would propagate to other\n"
"           clients of the server. Hopefully with SyncEvolution as\n"
"           client we'll have not much such changes. -->\n"
"      <updateclientinslowsync>yes</updateclientinslowsync>\n"
"      <updateserverinslowsync>yes</updateserverinslowsync>\n"
"\n"
"      <!--\n"
"          unconditionally disable the standard-compliant \"skip map phase\"\n"
"          behavior in favor of letting the client choose to restart the\n"
"          sync session if it has more changes\n"
"      -->\n"
"      <completefromclientonly>yes</completefromclientonly>\n"
"    </remoterule>\n"
"\n"
"    <remoterule name=\"MAEMO-CALENDAR\">\n"
"      <deviceid>none - this rule is activated via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"      <include rule=\"HAVE-EXDATE-DETACHED-NO-TZID\"/>\n"
"      <include rule=\"SIMPLE-EXDATE\"/>\n"
"    </remoterule>\n"
"    <!-- rule which enables all optional properties and parameters in the legacy format vCard -->\n"
"    <remoterule name=\"ALL\">\n"
"      <deviceid>none - this rule is activated via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT\"/>\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT-IN-IMPP\"/>\n"
"      <include rule=\"HAVE-ABLABEL-PARAMETER\"/>\n"
"    </remoterule>\n"
"    <remoterule name=\"EVOLUTION\">\n"
"      <deviceid>none - this rule is activated via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT\"/>\n"
"      <include rule=\"HAVE-ABLABEL-PARAMETER\"/>\n"
"      <!-- storing empty properties only wastes space and causes overhead, suppress them -->\n"
"      <noemptyproperties>yes</noemptyproperties>\n"
"    </remoterule>\n"
"    <!-- enable this rule if date fields like BDAY and REV shall use 1999-12-31 instead of 19991231 -->\n"
"    <subrule name=\"EXTENDED-DATE-FORMAT\"/>\n"
"    <remoterule name=\"KDE\">\n"
"      <deviceid>none - this rule is activated via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"    </remoterule>\n"
"    <remoterule name=\"LOCALSTORAGE\">\n"
"      <deviceid>none - this rule is activated by default via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"      <!-- storing empty properties only wastes space and causes overhead, suppress them -->\n"
"      <noemptyproperties>yes</noemptyproperties>\n"
"      <!-- enable storing of X-EVOLUTION-UI-SLOT -->\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT\"/>\n"
"      <include rule=\"HAVE-ABLABEL-PARAMETER\"/>\n"
"    </remoterule>\n"
"\n"
"    <subrule name=\"HAVE-VCARD-UID\">\n"
"      <!-- vCard Property UID is not parsed or generated by default,\n"
"           must be enabled for peers which support it. -->\n"
"    </subrule>\n"
"\n"
"    <remoterule name=\"LOCALSTORAGE-WITH-UID\">\n"
"      <deviceid>none - this rule is activated by default via its name in MAKE/PARSETEXTWITHPROFILE() macro calls</deviceid>\n"
"      <!-- storing empty properties only wastes space and causes overhead, suppress them -->\n"
"      <noemptyproperties>yes</noemptyproperties>\n"
"      <!-- enable storing of X-EVOLUTION-UI-SLOT -->\n"
"      <include rule=\"HAVE-EVOLUTION-UI-SLOT\"/>\n"
"      <include rule=\"HAVE-VCARD-UID\"/>\n"
"      <include rule=\"HAVE-ABLABEL-PARAMETER\"/>\n"
"    </remoterule>\n"
"      <remoterule name=\"ZYB\">\n"
"          <manufacturer>ZYB</manufacturer>\n"
"          <model>ZYB</model>\n"
"          <!-- information to disable anchors checking -->\n"
"          <lenientmode>yes</lenientmode>\n"
"      </remoterule>\n"
"\n"
"      <remoterule name=\"Mobical\">\n"
"          <manufacturer>Tactel AB</manufacturer>\n"
"          <model>Mobical Sync Server</model>\n"
"          <rulescript><![CDATA[\n"
"              alarmTimeToUTC = TRUE;\n"
"              ]]></rulescript>\n"
"      </remoterule>\n"
"\n"
"      <remoterule name=\"Google-Contacts\">\n"
"          <manufacturer>Google</manufacturer>\n"
"          <model>sync</model>\n"
"          <overridedevinf><![CDATA[\n"
"          <DevInf xmlns=\"syncml:devinf\">\n"
"          <VerDTD>1.2</VerDTD>\n"
"          <Man>Google</Man>\n"
"          <Mod>Sync</Mod>\n"
"          <OEM>-</OEM>\n"
"          <SwV>0.01</SwV>\n"
"          <HwV>-</HwV>\n"
"          <DevID>Google</DevID>\n"
"          <DevTyp>server</DevTyp>\n"
"          <UTC/>\n"
"          <SupportNumberOfChanges/>\n"
"          <SupportLargeObjs/>\n"
"          <DataStore>\n"
"          <SourceRef>contacts</SourceRef>\n"
"          <DisplayName>contacts</DisplayName>\n"
"          <MaxGUIDSize>32</MaxGUIDSize>\n"
"          <Rx-Pref>\n"
"          <CTType>text/x-vcard</CTType>\n"
"          <VerCT>2.1</VerCT>\n"
"          </Rx-Pref>\n"
"          <Tx-Pref>\n"
"          <CTType>text/x-vcard</CTType>\n"
"          <VerCT>2.1</VerCT>\n"
"          </Tx-Pref>\n"
"          <CTCap>\n"
"            <CTType>text/x-vcard</CTType>\n"
"            <VerCT>2.1</VerCT>\n"
"            <Property><PropName>BEGIN</PropName><ValEnum>VCARD</ValEnum></Property>\n"
"            <Property><PropName>END</PropName><ValEnum>VCARD</ValEnum></Property>\n"
"            <Property><PropName>VERSION</PropName>\n"
"              <ValEnum>2.1</ValEnum>\n"
"              <MaxOccur>1</MaxOccur>\n"
"            </Property>\n"
"            <Property><PropName>REV</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <Property><PropName>N</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <Property><PropName>FN</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <!-- Property><PropName>X-EVOLUTION-FILE-AS</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-GENDER</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>NICKNAME</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <Property><PropName>TITLE</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <!-- Property><PropName>CATEGORIES</PropName></Property -->\n"
"            <Property><PropName>ORG</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-X-Office</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>ROLE</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <Property><PropName>TEL</PropName>\n"
"              <PropParam>\n"
"                <ParamName>TYPE</ParamName>\n"
"                <ValEnum>HOME</ValEnum>\n"
"                <ValEnum>WORK</ValEnum>\n"
"                <ValEnum>VOICE</ValEnum>\n"
"                <ValEnum>CELL</ValEnum>\n"
"                <ValEnum>FAX</ValEnum>\n"
"                <ValEnum>PAGER</ValEnum>\n"
"                <ValEnum>PREF</ValEnum>\n"
"                <ValEnum>CAR</ValEnum>\n"
"                <!-- ValEnum>X-EVOLUTION-CALLBACK</ValEnum>\n"
"                <ValEnum>X-EVOLUTION-RADIO</ValEnum>\n"
"                <ValEnum>X-EVOLUTION-TELEX</ValEnum>\n"
"                <ValEnum>X-EVOLUTION-TTYTDD</ValEnum -->\n"
"              </PropParam>\n"
"            </Property>\n"
"            <Property><PropName>EMAIL</PropName>\n"
"              <PropParam>\n"
"                <ParamName>TYPE</ParamName>\n"
"                <ValEnum>HOME</ValEnum>\n"
"                <ValEnum>WORK</ValEnum>\n"
"                <ValEnum>INTERNET</ValEnum>\n"
"              </PropParam>\n"
"            </Property>\n"
"            <!-- Property><PropName>URL</PropName>\n"
"              <PropParam>\n"
"                <ParamName>TYPE</ParamName>\n"
"                <ValEnum>HOME</ValEnum>\n"
"                <ValEnum>WORK</ValEnum>\n"
"                <ValEnum>PREF</ValEnum>\n"
"              </PropParam>\n"
"            </Property -->\n"
"            <!-- Property><PropName>CALURI</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>FBURL</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-EVOLUTION-BLOG-URL</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-EVOLUTION-VIDEO-URL</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-MANAGER</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-ASSISTANT</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-SPOUSE</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-ANNIVERSARY</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-AIM</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-GADUGADU</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-GROUPWISE</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-ICQ</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-JABBER</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-MSN</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-YAHOO</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-SKYPE</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-SIP</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-messaging/irc-All</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-messaging/meanwhile-All</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-messaging/sms-All</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-CRYPTOENCRYPTPREF</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-CRYPTOPROTOPREF</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-CRYPTOSIGNPREF</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-OPENPGPFP</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-KADDRESSBOOK-X-IMAddress</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <!-- Property><PropName>X-MOZILLA-HTML</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <Property><PropName>ADR</PropName>\n"
"              <PropParam>\n"
"                <ParamName>TYPE</ParamName>\n"
"                <ValEnum>HOME</ValEnum>\n"
"                <ValEnum>WORK</ValEnum>\n"
"              </PropParam>\n"
"            </Property>\n"
"            <!-- Property><PropName>BDAY</PropName><MaxOccur>1</MaxOccur></Property -->\n"
"            <Property><PropName>NOTE</PropName><MaxOccur>1</MaxOccur></Property>\n"
"            <Property><PropName>PHOTO</PropName>\n"
"              <MaxOccur>1</MaxOccur>\n"
"              <PropParam>\n"
"                <ParamName>TYPE</ParamName>\n"
"                <ValEnum>JPEG</ValEnum>\n"
"              </PropParam>\n"
"            </Property>\n"
"          </CTCap>\n"
"          <SyncCap>\n"
"          <SyncType>1</SyncType>\n"
"          <SyncType>2</SyncType>\n"
"          </SyncCap>\n"
"          </DataStore>\n"
"          </DevInf>\n"
"          ]]></overridedevinf>\n"
"      </remoterule>\n"
"\n"
"      <remoterule name=\"Funambol\">\n"
"          <manufacturer>Funambol</manufacturer>\n"
"          <model>DS Server*</model>\n"
"          <rulescript><![CDATA[\n"
"             stripUID = TRUE;\n"
"          ]]></rulescript>\n"
"      </remoterule>\n"
;
